﻿Imports Infragistics.Win.UltraWinToolbars

''' <summary>
''' Ribbon Tool Navigation button 없애기 및 Dockmanager가 Ribbon밑에 Unppined 되었을 때 레이아웃과 5픽셀 정도 떨어뜨림.
''' </summary>
''' <remarks>
''' 2015-06-24 민유진 Created
''' </remarks>
Public Class CreatingUIElementCLS
    Implements Infragistics.Win.IUIElementCreationFilter


    Private meControl As ENUM_CONTROL = ENUM_CONTROL.NONE


    Public Sub New(ByVal peControl As ENUM_CONTROL)
        meControl = peControl
    End Sub


    Public Sub AfterCreateChildElements(ByVal parent As Infragistics.Win.UIElement) Implements Infragistics.Win.IUIElementCreationFilter.AfterCreateChildElements

        Select Case meControl

            Case ENUM_CONTROL.TOOLBAR, ENUM_CONTROL.RIBBONTOOLBAR

                If meControl = ENUM_CONTROL.RIBBONTOOLBAR Then
                    'Ribbon Tab의 Height Size를 줄여 위 간격을 살짝 띄운다.
                    Dim item As RibbonTabItemUIElement = TryCast(parent, RibbonTabItemUIElement)
                    If item IsNot Nothing Then
                        item.Rect = New Rectangle(item.Rect.X, item.Parent.Rect.Y + 3, item.Rect.Width, 20)
                    End If
                End If

                'Toolbar Navigation button 없애기
                Dim oElement As QatQuickCustomizeToolUIElement = TryCast(parent, QatQuickCustomizeToolUIElement)
                If oElement IsNot Nothing Then
                    oElement.Rect = New Rectangle(oElement.Rect.X, oElement.Rect.Y, 0, 0)
                End If

            Case ENUM_CONTROL.DOCKINGMGR
                'Docking이 Unppined 모드가 되었을때 상위 레이아웃과 5픽셀 정도 떨어뜨린다. 
                Dim tr As Infragistics.Win.UltraWinTabs.TabGroupUIElement = TryCast(parent, Infragistics.Win.UltraWinTabs.TabGroupUIElement)
                If tr IsNot Nothing Then
                    tr.Offset(0, 3)
                End If

        End Select

    End Sub

    Public Function BeforeCreateChildElements(ByVal parent As Infragistics.Win.UIElement) As Boolean Implements Infragistics.Win.IUIElementCreationFilter.BeforeCreateChildElements
        Return False
    End Function

End Class

#Region " 공통 Module "

Public Module mLControls

    Public Enum ENUM_CONTROL
        NONE
        TOOLBAR
        RIBBONTOOLBAR
        DOCKINGMGR
    End Enum

End Module

#End Region