﻿Imports System.ComponentModel
Imports Infragistics.Win.UltraWinSchedule

Public Class NABiCalendarLook
    Inherits Infragistics.Win.UltraWinSchedule.UltraCalendarLook
    Implements iNABiControlProperty

    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meUseFontStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE

#Region " Properties "

    <CategoryAttribute("NABi Design"), Browsable(True), Description("Font style 설정 (맑은고딕/9pt)")>
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle
        Get
            Return meUseFontStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseFontStyle = Value
            NABiSetFontStyle(meUseFontStyle)
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi style 사용 여부 설정")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle
        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value
            If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then
                NABiSetNABiStyle()
            End If
        End Set

    End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

#End Region


#Region " Public Methods "

    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle
        If peFontStyle = ENUM_TRUEFALSE.TRUE Then
            Me.DayHeaderAppearance.FontData.Name = NABI_FONTNAME
            Me.DayHeaderAppearance.FontData.SizeInPoints = NABI_GROUPBOX_FONTSIZE
            Me.DayHeaderAppearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True
        End If
    End Sub

#End Region

    Private Sub NABiSetNABiStyle()

        If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then
            Me.DayAppearance.BackColor = Color.White
            Me.DayAppearance.BackColor2 = Color.White
            Me.DayAppearance.BorderColor = Color.Silver
            Me.TodayHeaderAppearance.BackColor = Color.FromArgb(224, 224, 224)
            Me.TodayHeaderAppearance.BackColor = Color.Silver
            Me.TodayHeaderAppearance.BackGradientStyle = Infragistics.Win.GradientStyle.Vertical
            Me.TodayHeaderAppearance.BorderColor = Color.Silver
            Me.DayOfWeekHeaderAppearance.BackColor = Color.FromArgb(235, 235, 235)
            Me.DayOfWeekHeaderAppearance.ForeColor = Color.FromArgb(65, 65, 65)
            Me.DayHeaderAppearance.ForeColor = Color.FromArgb(65, 65, 65)
            '일요일은 빨강
            Me.DaysOfWeekLook(DayOfWeekEnum.Sunday).Appearance.ForeColor = Color.Red
            'Today Header 색
            Me.TodayHeaderAppearance.BackColor = Color.Silver
        End If

    End Sub

End Class
