﻿Imports System.ComponentModel
Imports Infragistics.Win

Public Class NABiCheckEditor
    Inherits Infragistics.Win.UltraWinEditors.UltraCheckEditor
    Implements iNABiControlProperty

#Region " Private Fields "

    Private meUseFontStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meCheckBoxType As ENUM_CHECKTYPE = ENUM_CHECKTYPE.NONE

#End Region

#Region " Properties "

    ''' <summary>
    ''' CheckBox type 선택
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks>
    ''' 2015-06-18 민유진 Created
    ''' </remarks>
    <CategoryAttribute("NABi Design"), Browsable(True), Description("CheckBox type 선택")> _
    Public Property NABiCheckBoxType() As ENUM_CHECKTYPE

        Get
            Return meCheckBoxType
        End Get
        Set(ByVal Value As ENUM_CHECKTYPE)
            meCheckBoxType = Value
            NABiSetCheckBoxType()
            Me.Invalidate()
        End Set

    End Property

    ''' <summary>
    ''' checkeditor Font style 자동 조절
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks>
    ''' 2015-06-17 민유진 Created
    ''' </remarks>
    <CategoryAttribute("NABi Design"), Browsable(True), Description("Font style 설정 (맑은고딕/9pt)")>
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle
        Get
            Return meUseFontStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseFontStyle = Value
            NABiSetFontStyle(meUseFontStyle)
            Me.Invalidate()
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

#End Region

#Region " Private Methods "

    ''' <summary>
    ''' checkeditor Type 설정
    ''' </summary>
    ''' <remarks>
    ''' 2015-06-17 민유진 Created
    ''' </remarks>
    Private Sub NABiSetCheckBoxType()

        If DesignMode Then

            Select Case meCheckBoxType

                Case ENUM_CHECKTYPE.CHECKBOX
                    NABiClearCheckBox()
                    'AddHandler Me.CheckStateChanged, AddressOf NABiClickedCheckBox
                    'RemoveHandler Me.CheckStateChanged, AddressOf NABiClickedButton

                    Me.UseOsThemes = DefaultableBoolean.False
                    Me.Style = EditCheckStyle.Button
                    'Me.Appearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True
                    Me.Appearance.TextHAlign = Infragistics.Win.HAlign.Left
                    Me.Appearance.TextVAlign = Infragistics.Win.VAlign.Middle
                    Me.ButtonStyle = Infragistics.Win.UIElementButtonStyle.Flat

                    Me.Appearance.BorderColor = Color.White
                    Me.Appearance.BackColor = Color.White
                    Me.Appearance.BackColor2 = Color.White

                    If Me.CheckState = Windows.Forms.CheckState.Unchecked Then
                        Me.Appearance.Image = My.Resources.checkbox_off
                    ElseIf Me.CheckState = Windows.Forms.CheckState.Checked Then
                        Me.Appearance.Image = My.Resources.checkbox_on
                    End If

                Case ENUM_CHECKTYPE.BUTTON
                    NABiClearCheckBox()
                    'AddHandler Me.CheckStateChanged, AddressOf NABiClickedButton
                    'RemoveHandler Me.CheckStateChanged, AddressOf NABiClickedCheckBox

                    Me.UseOsThemes = DefaultableBoolean.False
                    Me.Style = EditCheckStyle.Button
                    Me.Appearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True
                    Me.Appearance.TextHAlign = Infragistics.Win.HAlign.Center
                    Me.Appearance.TextVAlign = Infragistics.Win.VAlign.Middle
                    Me.ButtonStyle = Infragistics.Win.UIElementButtonStyle.Flat

                    Me.Appearance.BackColor = Color.FromArgb(239, 239, 239)
                    Me.Appearance.BackColor2 = Color.FromArgb(216, 216, 216)
                    Me.Appearance.BackGradientStyle = Infragistics.Win.GradientStyle.Vertical
                    Me.Appearance.BorderColor = Color.Silver
                    Me.Appearance.ForeColor = Color.FromArgb(50, 50, 50)
                    Me.Appearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.False
                    Me.CheckedAppearance.BackColor = Color.FromArgb(239, 239, 239)
                    Me.CheckedAppearance.BackColor2 = Color.FromArgb(216, 216, 216)
                    Me.CheckedAppearance.BackGradientStyle = Infragistics.Win.GradientStyle.Vertical
                    Me.CheckedAppearance.BorderColor = Color.Silver

                    If Me.CheckState = Windows.Forms.CheckState.Unchecked Then
                        Me.Appearance.Image = My.Resources.switch_off
                        Me.Appearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.False
                    Else
                        Me.Appearance.Image = My.Resources.switch_on
                        Me.Appearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True
                    End If

            End Select

        End If
        'quddnMe.Checked = Me.CheckState

    End Sub

    ''' <summary>
    ''' CheckBox Type이 Button style인 경우 ClickState에 따라 모양 변화
    ''' </summary>
    ''' <remarks>
    ''' 2015-06-17 민유진 Created
    ''' </remarks>
    Private Sub NABiClickedButton(sender As Object, e As EventArgs)

        Dim oNABiCheckEditor = CType(sender, Infragistics.Win.UltraWinEditors.UltraCheckEditor)

        If oNABiCheckEditor IsNot Nothing Then

            oNABiCheckEditor.StyleLibraryName = "None"

            If oNABiCheckEditor.CheckState = Windows.Forms.CheckState.Checked Then
                oNABiCheckEditor.Appearance.BackColor = Color.FromArgb(239, 239, 239)
                oNABiCheckEditor.Appearance.BackColor2 = Color.FromArgb(216, 216, 216)
                oNABiCheckEditor.Appearance.BackGradientStyle = Infragistics.Win.GradientStyle.Vertical
                oNABiCheckEditor.Appearance.BorderColor = Color.Silver
                oNABiCheckEditor.Appearance.ForeColor = Color.FromArgb(50, 50, 50)
                oNABiCheckEditor.Appearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True
                oNABiCheckEditor.ButtonStyle = Infragistics.Win.UIElementButtonStyle.Flat

                oNABiCheckEditor.CheckedAppearance.BackColor = Color.FromArgb(239, 239, 239)
                oNABiCheckEditor.CheckedAppearance.BackColor2 = Color.FromArgb(216, 216, 216)
                oNABiCheckEditor.CheckedAppearance.BackGradientStyle = Infragistics.Win.GradientStyle.Vertical
                oNABiCheckEditor.CheckedAppearance.BorderColor = Color.Silver
                oNABiCheckEditor.CheckedAppearance.ForeColor = Color.FromArgb(50, 50, 50)

                If oNABiCheckEditor.Appearance.StyleResourceName Is Nothing Then
                    oNABiCheckEditor.Appearance.Image = My.Resources.switch_on
                End If

            Else

                'Button인 경우 style적용
                oNABiCheckEditor.Appearance.BackColor = Color.FromArgb(239, 239, 239)
                oNABiCheckEditor.Appearance.BackColor2 = Color.FromArgb(216, 216, 216)
                oNABiCheckEditor.Appearance.BackGradientStyle = Infragistics.Win.GradientStyle.Vertical
                oNABiCheckEditor.Appearance.BorderColor = Color.Silver
                oNABiCheckEditor.Appearance.ForeColor = Color.FromArgb(50, 50, 50)
                oNABiCheckEditor.Appearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.False
                oNABiCheckEditor.ButtonStyle = Infragistics.Win.UIElementButtonStyle.Flat

                oNABiCheckEditor.CheckedAppearance.BackColor = Color.FromArgb(239, 239, 239)
                oNABiCheckEditor.CheckedAppearance.BackColor2 = Color.FromArgb(216, 216, 216)
                oNABiCheckEditor.CheckedAppearance.BackGradientStyle = Infragistics.Win.GradientStyle.Vertical
                oNABiCheckEditor.CheckedAppearance.BorderColor = Color.Silver

                If oNABiCheckEditor.Appearance.StyleResourceName Is Nothing Then
                    oNABiCheckEditor.Appearance.Image = My.Resources.switch_off
                End If

            End If


        End If
    End Sub

    ''' <summary>
    ''' NABi style인 경우 ClickState에 따라 모양 변화
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub NABiClickedCheckBox(sender As Object, e As EventArgs)

        Dim oNABiCheckEditor = CType(sender, Infragistics.Win.UltraWinEditors.UltraCheckEditor)

        If oNABiCheckEditor IsNot Nothing Then

            oNABiCheckEditor.StyleLibraryName = "None"

            If oNABiCheckEditor.CheckState = Windows.Forms.CheckState.Checked Then

                If oNABiCheckEditor.Appearance.StyleResourceName Is Nothing Then
                    oNABiCheckEditor.Appearance.Image = My.Resources.checkbox_on
                End If
                oNABiCheckEditor.Appearance.FontData.Bold = DefaultableBoolean.True

            Else

                If oNABiCheckEditor.Appearance.StyleResourceName Is Nothing Then
                    oNABiCheckEditor.Appearance.Image = My.Resources.checkbox_off
                End If
                oNABiCheckEditor.Appearance.FontData.Bold = DefaultableBoolean.False
            End If


        End If
    End Sub

    ''' <summary>
    ''' 디자인 초기화
    ''' </summary>
    ''' <remarks>
    ''' 2015-06-17 민유진 Created
    ''' </remarks>
    Private Sub NABiClearCheckBox()

        Me.Appearance.TextHAlign = Infragistics.Win.HAlign.Default
        Me.Appearance.TextVAlign = Infragistics.Win.VAlign.Default

        Me.Appearance.BackColor = Nothing
        Me.Appearance.BackColor2 = Nothing
        Me.Appearance.BackGradientStyle = Infragistics.Win.GradientStyle.Default
        Me.Appearance.BorderColor = Nothing
        Me.Appearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.Default
        Me.ButtonStyle = Infragistics.Win.UIElementButtonStyle.Default

        Me.CheckedAppearance.BackColor = Nothing
        Me.CheckedAppearance.BackColor2 = Nothing
        Me.CheckedAppearance.BackGradientStyle = Infragistics.Win.GradientStyle.Default
        Me.CheckedAppearance.BorderColor = Nothing

        If meCheckBoxType = ENUM_CHECKTYPE.BUTTON Then
            Me.Appearance.ForeColor = Nothing
            Me.CheckedAppearance.ForeColor = Nothing
        End If

        Me.Appearance.Image = Nothing

    End Sub

    ''' <summary>
    ''' Font style 설정
    ''' </summary>
    ''' <param name="peFontStyle"></param>
    ''' <remarks></remarks>
    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle

        If peFontStyle = ENUM_TRUEFALSE.TRUE Then
            Me.Appearance.FontData.Name = NABI_FONTNAME
            Me.Appearance.FontData.SizeInPoints = NABI_FONTSIZE
        ElseIf peFontStyle = ENUM_TRUEFALSE.FALSE Then
            Me.Appearance.FontData.Name = Nothing
            Me.Appearance.FontData.SizeInPoints = Nothing
        End If

    End Sub

#End Region

#Region " Events "

    ''' <summary>
    ''' Check 상태 변경 Event
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub NABiCheckEditor_CheckStateChanged(sender As Object, e As EventArgs) Handles Me.CheckStateChanged

        Select Case meCheckBoxType

            Case ENUM_CHECKTYPE.CHECKBOX

                NABiClickedCheckBox(sender, e)

            Case ENUM_CHECKTYPE.BUTTON

                NABiClickedButton(sender, e)

        End Select

    End Sub

#End Region

End Class
