﻿Imports System.ComponentModel

Public Class NABiComboEditor
    Inherits Infragistics.Win.UltraWinEditors.UltraComboEditor
    Implements iNABiControlProperty


#Region " Private Fields "

    Private meDropDownList As ENUM_TRUEFALSE = ENUM_TRUEFALSE.TRUE
    Private meBindMasterData As ENUM_BINDMASTER = ENUM_BINDMASTER.NONE
    Private meBindDTLData As ENUM_BINDDETAIL = ENUM_BINDDETAIL.NONE

    Private meUseFontStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE

#End Region

#Region " Properties "

    ''' <summary>
    ''' ComboEditor Font style 자동 조절
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks>
    ''' 2015-06-17 민유진 Created
    ''' </remarks>
    <CategoryAttribute("NABi Design"), Browsable(True), Description("Font style 설정 (맑은고딕/9pt)")>
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle
        Get
            Return meUseFontStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseFontStyle = Value
            NABiSetFontStyle(meUseFontStyle)
            Me.Invalidate()
        End Set
    End Property

    ''' <summary>
    ''' DropDownList 사용여부
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks>
    ''' 2015-06-17 민유진 Created
    ''' </remarks>
    <CategoryAttribute("NABi Design"), Browsable(True), Description("DropDownList 사용여부")> _
    Public Property NABiUseDropDownList() As ENUM_TRUEFALSE

        Get
            Return meDropDownList
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meDropDownList = Value

            If Value = ENUM_TRUEFALSE.TRUE Then
                MyBase.DropDownStyle = Infragistics.Win.DropDownStyle.DropDownList
            Else
                MyBase.DropDownStyle = Infragistics.Win.DropDownStyle.DropDown
            End If

            Me.Invalidate()
        End Set

    End Property


    ''' <summary>
    ''' 바인딩 할 마스터 Table 선택
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks>
    ''' 2015-06-17 민유진 Created
    ''' </remarks>
    <CategoryAttribute("NABi Design"), Browsable(True), Description("바인딩 할 마스터 Table 선택")> _
    Public Property NABiBindMaster() As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

        Get
            Return meBindMasterData
        End Get
        Set(ByVal Value As ENUM_BINDMASTER)
            meBindMasterData = Value
            Me.Invalidate()
        End Set

    End Property

    ''' <summary>
    ''' 바인딩 할 DTL 마스터 선택
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks>
    ''' 2015-06-17 민유진 Created
    ''' </remarks>
    <CategoryAttribute("NABi Design"), Browsable(True), Description("바인딩 할 DTL 마스터 Table 선택")> _
    Public Property NABiBindDTL() As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

        Get
            Return meBindDTLData
        End Get
        Set(ByVal Value As ENUM_BINDDETAIL)
            meBindDTLData = Value
            Me.Invalidate()
        End Set

    End Property


    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

#End Region

#Region " Private Methods "

    ''' <summary>
    ''' Font style 설정
    ''' </summary>
    ''' <param name="peFontStyle"></param>
    ''' <remarks></remarks>
    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle

        If peFontStyle = ENUM_TRUEFALSE.TRUE Then
            Me.Appearance.FontData.Name = NABI_FONTNAME
            Me.Appearance.FontData.SizeInPoints = NABI_FONTSIZE
        ElseIf peFontStyle = ENUM_TRUEFALSE.FALSE Then
            Me.Appearance.FontData.Name = Nothing
            Me.Appearance.FontData.SizeInPoints = Nothing
        End If

    End Sub

#End Region

End Class
