﻿Imports System.ComponentModel
Imports Infragistics.Win.UltraWinDock

<Serializable()>
Public Class NABiDockManager
    Inherits Infragistics.Win.UltraWinDock.UltraDockManager
    Implements iNABiControlProperty


#Region " Private Fields "

    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meShowCaption As ENUM_TRUEFALSE = ENUM_TRUEFALSE.TRUE
    Private meLayoutStyle As DockAreaLayoutStyle = DockAreaLayoutStyle.Standard

#End Region

#Region " Properties "

    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi 스타일 Docking 설정")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle
        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value
            NABiSetDockingStyle()
        End Set

    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi Docking LayoutStyle 설정")> _
    Public Property NABiDockLayoutStyle() As DockAreaLayoutStyle

        Get
            Return meLayoutStyle
        End Get
        Set(ByVal Value As DockAreaLayoutStyle)
            meLayoutStyle = Value
            If meLayoutStyle = DockAreaLayoutStyle.Standard Then
                Me.LayoutStyle = DockAreaLayoutStyle.Standard
            Else
                Me.LayoutStyle = DockAreaLayoutStyle.FillContainer
            End If
        End Set

    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("Docking caption 보기 여부 설정")> _
    Public Property NABiShowCaption() As ENUM_TRUEFALSE

        Get
            Return meShowCaption
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meShowCaption = Value
            NABiShowDockingCaption(meShowCaption)
        End Set

    End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

#End Region

#Region " Constructors "

    Public Sub New()
        MyBase.New()
    End Sub

    Public Sub New(container As IContainer)
        MyBase.New(container)
    End Sub

    Public Sub New(info As System.Runtime.Serialization.SerializationInfo, context As System.Runtime.Serialization.StreamingContext)
        MyBase.New(info, context)
    End Sub

#End Region

#Region " Private Methods "

    ''' <summary>
    ''' docking style 설정
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub NABiSetDockingStyle()

        If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then

            Me.CreationFilter = New CreatingUIElementCLS(ENUM_CONTROL.DOCKINGMGR)

            '간격 1픽셀 띄우기
            Me.DefaultPaneSettings.PaddingBottom = 1
            Me.DefaultPaneSettings.PaddingTop = 1
            Me.DefaultPaneSettings.PaddingLeft = 1
            Me.DefaultPaneSettings.PaddingRight = 1


            Me.DefaultGroupSettings.TabLocation = Infragistics.Win.UltraWinDock.Location.Top
            Me.DefaultGroupSettings.TabStyle = Infragistics.Win.UltraWinTabs.TabStyle.VisualStudio2005
            Me.DefaultPaneSettings.Appearance.FontData.Name = NABI_FONTNAME

            'Split  간격 & 색상
            Me.SplitterBarWidth = 1
            Me.SplitterBarAppearance.BackColor = Color.White

            'Unpin Tab Style
            Me.UnpinnedTabStyle = Infragistics.Win.UltraWinTabs.TabStyle.VisualStudio2005

            'Style 은 기본
            Me.WindowStyle = Infragistics.Win.UltraWinDock.WindowStyle.Default

            'Unpinned 했을때 Caption 높이 지정
            Me.ImageSizeCaption = New Size(25, 25)

            Me.DefaultPaneSettings.Appearance.BackColor = Color.White

            'Caption 보일 때 Style
            Me.DefaultPaneSettings.ActiveCaptionAppearance.BorderColor = Color.White
            Me.DefaultPaneSettings.CaptionAppearance.BorderColor = Color.White
            Me.DefaultPaneSettings.HorizontalCaptionGrabHandleAppearance.BorderColor = Color.White
            Me.DefaultPaneSettings.VerticalCaptionGrabHandleAppearance.BorderColor = Color.White
            Me.DefaultPaneSettings.BorderStyleCaption = Infragistics.Win.UIElementBorderStyle.Rounded1

            'Docking pin 빠르게 움직이도록
            Me.AutoHideDelay = 1
            Me.AnimationSpeed = Infragistics.Win.UltraWinDock.AnimationSpeed.StandardSpeedPlus2


        ElseIf meUseNABiStyle = ENUM_TRUEFALSE.FALSE Then
            '간격
            Me.DefaultPaneSettings.PaddingBottom = Nothing
            Me.DefaultPaneSettings.PaddingTop = Nothing
            Me.DefaultPaneSettings.PaddingLeft = Nothing
            Me.DefaultPaneSettings.PaddingRight = Nothing


            Me.DefaultGroupSettings.TabLocation = Infragistics.Win.UltraWinDock.Location.Default
            Me.DefaultGroupSettings.TabStyle = Infragistics.Win.UltraWinTabs.TabStyle.Default
            Me.DefaultPaneSettings.Appearance.FontData.Name = Nothing


            'Split  간격 & 색상
            Me.SplitterBarWidth = 1
            Me.SplitterBarAppearance.BackColor = Nothing

            'Unpin Tab Style
            Me.UnpinnedTabStyle = Infragistics.Win.UltraWinTabs.TabStyle.Default

            'Style 은 기본
            Me.WindowStyle = Infragistics.Win.UltraWinDock.WindowStyle.Default

            'Unpinned 했을때 Caption 높이 지정
            Me.ImageSizeCaption = Nothing

            Me.DefaultPaneSettings.Appearance.BackColor = Nothing
        End If

    End Sub

    ''' <summary>
    ''' Caption 보기 설정
    ''' </summary>
    ''' <param name="peShowCaption"></param>
    ''' <remarks></remarks>
    Private Sub NABiShowDockingCaption(peShowCaption As ENUM_TRUEFALSE)

        If peShowCaption = ENUM_TRUEFALSE.TRUE Then
            Me.DefaultPaneSettings.ShowCaption = Infragistics.Win.DefaultableBoolean.Default

        ElseIf peShowCaption = ENUM_TRUEFALSE.FALSE Then
            Me.DefaultPaneSettings.ShowCaption = Infragistics.Win.DefaultableBoolean.False
        End If

    End Sub

    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle
        'Nothing
    End Sub

#End Region


End Class
