﻿Imports System.ComponentModel

Public Class NABiDropDownButton
    Inherits Infragistics.Win.Misc.UltraDropDownButton
    Implements iNABiControlProperty


#Region " Private Fields "

    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meUseFontStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE

#End Region

#Region " Properties "

    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi 스타일 그룹박스 설정")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle
        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value
            If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then
                NABiSetNABiStyle()
                Me.Invalidate()
            End If
        End Set

    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("Font style 설정 (맑은고딕/9pt)")>
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle
        Get
            Return meUseFontStyle
        End Get
        Set(value As ENUM_TRUEFALSE)
            meUseFontStyle = value
            NABiSetFontStyle(meUseFontStyle)
            Me.Invalidate()
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

#End Region

#Region " Mothods "

    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle
        If meUseFontStyle = ENUM_TRUEFALSE.TRUE Then
            Me.Appearance.FontData.Name = NABI_FONTNAME
            Me.Appearance.FontData.SizeInPoints = NABI_GROUPBOX_FONTSIZE
        End If
    End Sub

    Private Sub NABiSetNABiStyle()

        If Not DesignMode Then
            Me.Region = RoundControlCLS.RoundedRegion(Me.ClientRectangle, 1, RoundControlCLS.Corner.None)
        End If
        Me.StyleLibraryName = "none"
        Me.Appearance.BackColor = Color.White
        Me.Appearance.BorderColor = Color.Silver
        Me.ButtonStyle = Infragistics.Win.UIElementButtonStyle.Flat
        Me.Style = Infragistics.Win.Misc.SplitButtonDisplayStyle.DropDownButtonOnly
        Me.UseOsThemes = Infragistics.Win.DefaultableBoolean.False

    End Sub

#End Region
   
End Class
