﻿Imports System.ComponentModel

Public Class NABiExpandableGroupBox
    Inherits Infragistics.Win.Misc.UltraExpandableGroupBox
    Implements iNABiControlProperty


#Region " Private Fields "

    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meUseFontStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE

#End Region

#Region " Properties "

    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle
        Get
            Return meUseFontStyle
        End Get
        Set(value As ENUM_TRUEFALSE)
            meUseFontStyle = value
            NABiSetFontStyle(meUseFontStyle)
            Me.Invalidate()
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi 스타일 ExpandableGroupBox 설정")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle
        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value
            NABiSetExpandableGroupBoxStyle()
            Me.Invalidate()
        End Set

    End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

#End Region

#Region " Private Methods "

    ''' <summary>
    ''' NABi Style 설정
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub NABiSetExpandableGroupBoxStyle()

        If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then

            Me.Appearance.BackColor = Color.White
            Me.HeaderAppearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True
            Me.HeaderAppearance.ForeColor = Color.FromArgb(20, 148, 184)

        ElseIf meUseNABiStyle = ENUM_TRUEFALSE.FALSE Then

            Me.Appearance.BackColor = Nothing
            Me.HeaderAppearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.Default
            Me.HeaderAppearance.FontData.Name = Nothing
            Me.HeaderAppearance.ForeColor = Nothing
            Me.HeaderAppearance.FontData.SizeInPoints = Nothing

        End If

    End Sub

    ''' <summary>
    ''' NABi FontStyle 설정
    ''' </summary>
    ''' <param name="peFontStyle"></param>
    ''' <remarks></remarks>
    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle

        If peFontStyle = ENUM_TRUEFALSE.TRUE Then
            Me.Appearance.FontData.Name = NABI_FONTNAME
            Me.Appearance.FontData.SizeInPoints = NABI_GROUPBOX_FONTSIZE
        ElseIf peFontStyle = ENUM_TRUEFALSE.FALSE Then

        End If

    End Sub

#End Region


End Class
