﻿Imports System.ComponentModel
Imports Infragistics.Win.UltraWinForm
Imports NABi.UI.Common

Public Class NABiFormManager
    Inherits Infragistics.Win.UltraWinForm.UltraFormManager
    Implements iNABiControlProperty

#Region " Private Fields "

    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meUseFontStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE

    Private moMainForm As Form
    Private meUseEffect As ENUM_USEEFFECT = ENUM_USEEFFECT.FALSE
    Private moUseESCCloseForm As ENUM_TRUEFALSE = ENUM_TRUEFALSE.TRUE

    Public Event EVENT_FORMMANAGER_CLOSE_CLICK()

#End Region

#Region " Properties "

    ''' <summary>
    ''' ESC Key로 Form을 닫을 지 여부 지정
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks>
    ''' 2015-06-18 민유진 Created
    ''' </remarks>
    <CategoryAttribute("NABi Design"), Browsable(True), Description("ESC Key로 Form을 닫을 지 여부")> _
    Public Property NABiUseESCCloseForm() As ENUM_TRUEFALSE

        Get
            Return moUseESCCloseForm
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            moUseESCCloseForm = Value
        End Set

    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi Sub Form Style 사용 여부 설정")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle
        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value
            moMainForm = Me.Form
            NABiSetFormDesign()
        End Set

    End Property

    ''' <summary>
    ''' subform뒤에 Effect효과 사용 여부
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks>
    ''' 2015-06-18 민유진 Created
    ''' </remarks>
    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi SubForm 뒤에 Effect 효과 사용 여부 설정")> _
    Public Property NABiUseEffectForm() As ENUM_USEEFFECT

        Get
            Return meUseEffect
        End Get
        Set(ByVal Value As ENUM_USEEFFECT)
            meUseEffect = Value
        End Set

    End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

#End Region

#Region " Constructors "

    Public Sub New(container As IContainer)
        MyBase.New(container)
    End Sub

#End Region

#Region " Overrides Methods "

    ''' <summary>
    ''' 실행후 effect효과 및 keyevent등록
    ''' Event만 등록
    ''' </summary>
    ''' <remarks>
    ''' 2015-06-18 민유진 Created
    ''' </remarks>
    Protected Overrides Sub OnEndInit()
        If DesignMode Then
            Return
        End If

        'Dim bShowEffectForm As Boolean = False

        moMainForm.KeyPreview = True

        If moUseESCCloseForm = ENUM_TRUEFALSE.TRUE Then
            AddHandler moMainForm.KeyDown, AddressOf EVENT_KEYDOWN
            AddHandler moMainForm.Load, AddressOf EVENT_LOADFORM
        Else
            RemoveHandler moMainForm.KeyDown, AddressOf EVENT_KEYDOWN
        End If

        'Effect효과는 load이벤트시 생성. Showdialog가 이루어진 상태에서 해야함.
        'If meUseEffect = ENUM_USEEFFECT.TRUE Then
        '    'Effect 효과 무조건 넣음
        '    bShowEffectForm = True

        'ElseIf meUseEffect = ENUM_USEEFFECT.DEFAULT Then

        '    If Me.moMainForm.Modal = True Then
        '        'Default지만 Modal 창이라면 Effect 효과 무조건 넣음
        '        bShowEffectForm = True
        '    Else
        '        bShowEffectForm = False
        '    End If

        'Else
        '    bShowEffectForm = False

        'End If

        'If bShowEffectForm Then

        '    Dim oEffect As New EffectFormCLS(Me.Form)
        '    oEffect.BMISShowEffectForm()

        'End If

        MyBase.OnEndInit()

    End Sub

#End Region

#Region " Private Methods "

    ''' <summary>
    ''' Form 디자인
    ''' </summary>
    ''' <remarks>
    ''' 2015-06-18 민유진 Created
    ''' </remarks>
    Private Sub NABiSetFormDesign()

        If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then

            Me.FormStyleSettings.CaptionAreaActiveAppearance.BackColor = Color.FromArgb(240, 240, 240)
            Me.FormStyleSettings.CaptionAreaActiveAppearance.BackColor2 = Color.FromArgb(240, 240, 240)
            Me.FormStyleSettings.CaptionAreaActiveAppearance.ForeColor = Color.FromArgb(5, 74, 101)
            Me.FormStyleSettings.CaptionAreaActiveAppearance.BorderColor = Color.FromArgb(230, 230, 230)
            Me.FormStyleSettings.CaptionAreaActiveAppearance.BorderColor2 = Color.FromArgb(230, 230, 230)
            Me.FormStyleSettings.CaptionAreaActiveAppearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True
            Me.FormStyleSettings.CaptionAreaActiveAppearance.FontData.Name = "맑은 고딕"
            Me.FormStyleSettings.CaptionAreaActiveAppearance.FontData.SizeInPoints = 10
            Me.FormStyleSettings.Style = UltraFormStyle.Office2013
            Me.FormStyleSettings.CaptionButtonsAppearances.CloseButtonAppearances.Appearance.Image = My.Resources.CLOSE
            Me.FormStyleSettings.CaptionButtonsAppearances.MaximizeButtonAppearances.Appearance.Image = My.Resources.MAX
            Me.FormStyleSettings.CaptionButtonsAppearances.MinimizeButtonAppearances.Appearance.Image = My.Resources.MIN
            Me.FormStyleSettings.CaptionButtonsAppearances.RestoreButtonAppearances.Appearance.Image = My.Resources.Restore

        ElseIf meUseNABiStyle = ENUM_TRUEFALSE.FALSE Then

            Me.FormStyleSettings.CaptionAreaActiveAppearance.BackColor = Nothing
            Me.FormStyleSettings.CaptionAreaActiveAppearance.BackColor2 = Nothing
            Me.FormStyleSettings.CaptionAreaActiveAppearance.ForeColor = Nothing
            Me.FormStyleSettings.CaptionAreaActiveAppearance.BorderColor = Nothing
            Me.FormStyleSettings.CaptionAreaActiveAppearance.BorderColor2 = Nothing
            Me.FormStyleSettings.CaptionAreaActiveAppearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.Default
            Me.FormStyleSettings.CaptionAreaActiveAppearance.FontData.SizeInPoints = 10
            Me.FormStyleSettings.Style = UltraFormStyle.Default
            Me.FormStyleSettings.CaptionButtonsAppearances.CloseButtonAppearances.Appearance.Image = Nothing
            Me.FormStyleSettings.CaptionButtonsAppearances.MaximizeButtonAppearances.Appearance.Image = Nothing
            Me.FormStyleSettings.CaptionButtonsAppearances.MinimizeButtonAppearances.Appearance.Image = Nothing
            Me.FormStyleSettings.CaptionButtonsAppearances.RestoreButtonAppearances.Appearance.Image = Nothing

        End If


    End Sub

    ''' <summary>
    ''' 닫기 이벤트
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2015-06-18 민유진 Created
    ''' </remarks>
    Private Sub EVENT_KEYDOWN(sender As Object, e As KeyEventArgs)
        If e.KeyCode = Keys.Escape Then
            moMainForm.Close()
        End If
    End Sub

    ''' <summary>
    ''' Form이 로드되면 Effect효과 설정
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub EVENT_LOADFORM(sender As Object, e As EventArgs)

        Dim bShowEffectForm As Boolean = False


        If meUseEffect = ENUM_USEEFFECT.TRUE Then
            'Effect 효과 무조건 넣음
            bShowEffectForm = True

        ElseIf meUseEffect = ENUM_USEEFFECT.DEFAULT Then

            If Me.moMainForm.Modal = True Then
                'Default지만 Modal 창이라면 Effect 효과 무조건 넣음
                bShowEffectForm = True
            Else
                bShowEffectForm = False
            End If

        Else
            bShowEffectForm = False

        End If

        If bShowEffectForm Then

            Dim oEffect As New EffectFormCLS(Me.Form)
            oEffect.BMISShowEffectForm()

        End If

    End Sub

#End Region

#Region " Public Methods "

    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle
        'Nothing
    End Sub

#End Region

    

End Class
