﻿Imports System.ComponentModel

Public Class NABiGroupBox
    Inherits Infragistics.Win.Misc.UltraGroupBox
    Implements iNABiControlProperty

#Region " Private Fields "

    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meUseFontStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE

#End Region

#Region " Properties "

    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi 스타일 그룹박스 설정")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle
        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value
            NABiSetGroupBoxStyle()
            Me.Invalidate()
        End Set

    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("Font style 설정 (맑은고딕/9pt)")>
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle
        Get
            Return meUseFontStyle
        End Get
        Set(value As ENUM_TRUEFALSE)
            meUseFontStyle = value
            NABiSetFontStyle(meUseFontStyle)
            Me.Invalidate()
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

#End Region

#Region " Private Methods "

    ''' <summary>
    ''' GroupBox Style 적용
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub NABiSetGroupBoxStyle()

        If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then

            Me.Appearance.BackColor = Color.White
            Me.HeaderAppearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True
            Me.HeaderAppearance.ForeColor = Color.FromArgb(20, 148, 184)

        End If

    End Sub

    ''' <summary>
    ''' NABi Font 설정
    ''' </summary>
    ''' <param name="peFontStyle"></param>
    ''' <remarks></remarks>
    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle
        If peFontStyle = ENUM_TRUEFALSE.TRUE Then
            Me.Appearance.FontData.Name = NABI_FONTNAME
            Me.Appearance.FontData.SizeInPoints = NABI_GROUPBOX_FONTSIZE
        End If
    End Sub

#End Region

End Class
