﻿Imports System.ComponentModel

Public Class NABiListBar
    Inherits Infragistics.Win.UltraWinListBar.UltraListBar
    Implements iNABiControlProperty

#Region " Private Fields "

    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meUseFontStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE

#End Region

#Region " Properties "

    <CategoryAttribute("NABi Design"), Browsable(True), Description("Font style 설정 (맑은고딕/9pt)")> _
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle
        Get
            Return meUseFontStyle
        End Get
        Set(value As ENUM_TRUEFALSE)
            meUseFontStyle = value
            NABiSetFontStyle(meUseFontStyle)
            Me.Invalidate()
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi style 사용 여부")>
        Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle
        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value
            If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then
                NABiSetNABiStyle()
            End If
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

#End Region

#Region " Public Methods "

    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle
        If peFontStyle = ENUM_TRUEFALSE.TRUE Then
            Me.Appearance.FontData.Name = NABI_FONTNAME
            Me.Appearance.FontData.SizeInPoints = NABI_FONTSIZE
        ElseIf peFontStyle = ENUM_TRUEFALSE.FALSE Then
            Me.Appearance.StyleLibraryName = Nothing
            Me.Appearance.FontData.Name = Nothing
            Me.Appearance.FontData.SizeInPoints = Nothing
        End If
    End Sub

    Private Sub NABiSetNABiStyle()

        Me.UseOsThemes = Infragistics.Win.DefaultableBoolean.False
        Me.Appearance.BackColor = Color.White
        Me.Appearance.BorderColor = NABI_BORDERCOLOR
        Me.BorderStyle = Infragistics.Win.UIElementBorderStyle.Rounded1
        Me.UseFlatMode = Infragistics.Win.DefaultableBoolean.True

        Me.HeaderAppearance.BackColor = Color.FromArgb(93, 126, 145)
        Me.HeaderAppearance.BackColor2 = Color.FromArgb(137, 157, 168)
        Me.HeaderAppearance.BorderColor = Color.White
        Me.HeaderAppearance.BackGradientStyle = Infragistics.Win.GradientStyle.Horizontal

        Me.HeaderAppearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True
        Me.HeaderAppearance.ForeColor = Color.FromArgb(251, 255, 255)

    End Sub

#End Region

End Class
