﻿Imports System.ComponentModel

Public Class NABiListView
    Inherits Infragistics.Win.UltraWinListView.UltraListView
    Implements iNABiControlProperty


#Region " Private Fields "

    Private meBindMasterData As ENUM_BINDMASTER = ENUM_BINDMASTER.NONE
    Private meBindDTLData As ENUM_BINDDETAIL = ENUM_BINDDETAIL.NONE
    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meUseFontStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE

#End Region

#Region " Public Properties "

    ''' <summary>
    ''' 바인딩 할 마스터 선택
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks>
    ''' 2015-06-17 민유진 Created
    ''' </remarks>
    <CategoryAttribute("NABi Design"), Browsable(True)> _
    Public Property NABiBindMaster() As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

        Get
            Return meBindMasterData
        End Get
        Set(ByVal Value As ENUM_BINDMASTER)
            meBindMasterData = Value
            Me.Invalidate()
        End Set

    End Property

    ''' <summary>
    ''' 바인딩 할 DTL 마스터 선택
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks>
    ''' 2015-06-17 민유진 Created
    ''' </remarks>
    <CategoryAttribute("NABi Design"), Browsable(True)> _
    Public Property NABiBindDTL() As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

        Get
            Return meBindDTLData
        End Get
        Set(ByVal Value As ENUM_BINDDETAIL)
            meBindDTLData = Value
            Me.Invalidate()
        End Set

    End Property


    <CategoryAttribute("NABi Design"), Browsable(True), Description("Font style 설정 (맑은고딕/9pt)")>
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle
        Get
            Return meUseFontStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseFontStyle = Value
            NABiSetFontStyle(meUseFontStyle)
            Me.Invalidate()
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("ListView style 설정 (Border)")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle
        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value
            NABiSetListViewStyle(meUseNABiStyle)
            Me.Invalidate()
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

#End Region

#Region " Private Methods "

    ''' <summary>
    ''' NABi Style 설정
    ''' </summary>
    ''' <param name="meUseNABiStyle"></param>
    ''' <remarks></remarks>
    Private Sub NABiSetListViewStyle(meUseNABiStyle As ENUM_TRUEFALSE)

        If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then
            Me.UseOsThemes = Infragistics.Win.DefaultableBoolean.False
            Me.Appearance.BorderColor = NABI_BORDERCOLOR
            Me.BorderStyle = Infragistics.Win.UIElementBorderStyle.Rounded1
        End If

    End Sub

    ''' <summary>
    ''' NABi Font 설정
    ''' </summary>
    ''' <param name="peFontStyle"></param>
    ''' <remarks></remarks>
    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle
        If peFontStyle = ENUM_TRUEFALSE.TRUE Then
            Me.Appearance.FontData.Name = NABI_FONTNAME
            Me.Appearance.FontData.SizeInPoints = NABI_FONTSIZE
        End If
    End Sub

#End Region

End Class
