﻿Imports System.ComponentModel

Public Class NABiMaskedEdit
    Inherits Infragistics.Win.UltraWinMaskedEdit.UltraMaskedEdit
    Implements iNABiControlProperty

#Region " Private Fields "

    Private meTextBoxType As ENUM_TEXTBOXTYPE = ENUM_TEXTBOXTYPE.WRITE_LEFT
    Private meMaskFormat As ENUM_MASKFORMAT = ENUM_MASKFORMAT.NONE
    Private meUseFontStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meUseNullType As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE

#End Region

#Region " Properties "

    ' ''' <summary>
    ' ''' MaskEditor Font style 자동 조절
    ' ''' </summary>
    ' ''' <value></value>
    ' ''' <returns></returns>
    ' ''' <remarks>
    ' ''' 2015-06-17 민유진 Created
    ' ''' </remarks>
    '<CategoryAttribute("NABi Design"), Browsable(True), Description("MaskEditor font style 설정 (맑은고딕/9pt)")> _
    'Public Property NABiUseFontStyle() As ENUM_TRUEFALSE
    '    Get
    '        Return meUseMaskEditorFontStyle
    '    End Get
    '    Set(ByVal Value As ENUM_TRUEFALSE)
    '        meUseMaskEditorFontStyle = Value
    '        NABiSetMaskEditorFontStyle(meUseMaskEditorFontStyle)
    '        Me.Invalidate()
    '    End Set
    'End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("Font style 설정 (맑은고딕/9pt)")>
       Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle
        Get
            Return meUseFontStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseFontStyle = Value
            NABiSetFontStyle(meUseFontStyle)
            Me.Invalidate()
        End Set
    End Property

    ''' <summary>
    ''' 마스크 포멧 설정
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks>
    ''' 2015-06-17 민유진 Created
    ''' </remarks>
    <CategoryAttribute("NABi Design"), Browsable(True), Description("MaskEditor Format 설정")> _
    Public Property NABiMaskFormat() As ENUM_MASKFORMAT
        Get
            Return meMaskFormat
        End Get
        Set(ByVal Value As ENUM_MASKFORMAT)
            meMaskFormat = Value

            NABiSetMaskFormatType()

            Me.Invalidate()
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

    ''' <summary>
    ''' TextBox 정렬및 읽기/쓰기용 선택
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <CategoryAttribute("NABi Design"), Browsable(True), Description("TextBox 정렬및 읽기/쓰기용 선택")> _
    Public Property NABiTextBoxType() As ENUM_TEXTBOXTYPE
        Get
            Return meTextBoxType
        End Get
        Set(ByVal Value As ENUM_TEXTBOXTYPE)
            meTextBoxType = Value
            NABiSetTextBoxType()
            Me.Invalidate()
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("DateTime 현재 시간 설정")> _
    Public Property NABiUseNullType() As ENUM_TRUEFALSE
        Get
            Return meUseNullType
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNullType = Value
            NABiSetNullType(meUseNullType)
            Me.Invalidate()
        End Set
    End Property

#End Region

#Region " Private Methods "

    ' ''' <summary>
    ' ''' Font style 설정
    ' ''' </summary>
    ' ''' <remarks>
    ' ''' 2015-06-23 민유진 Created
    ' ''' </remarks>
    'Private Sub NABiSetMaskEditorFontStyle(peUseMaskEditorFontStyle As ENUM_TRUEFALSE)
    '    If peUseMaskEditorFontStyle = ENUM_TRUEFALSE.TRUE Then
    '        Me.Appearance.FontData.Name = NABI_FONTNAME
    '        Me.Appearance.FontData.SizeInPoints = NABI_FONTSIZE
    '    ElseIf peUseMaskEditorFontStyle = ENUM_TRUEFALSE.FALSE Then
    '        Me.Appearance.FontData.Name = Nothing
    '        Me.Appearance.FontData.SizeInPoints = Nothing
    '    End If
    'End Sub

    Private Sub InitializeComponent()
        Me.SuspendLayout()
        '
        'NABiMaskedEdit
        '
        Me.NonAutoSizeHeight = 21
        Me.ResumeLayout(False)

    End Sub

    ''' <summary>
    ''' 
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub NABiSetMaskFormatType()

        Dim iRegSize As Integer = 110
        Dim iDateSize As Integer = 95
        Dim iDateTimeSize As Integer = 130
        Dim iDateTimeSec As Integer = 140
        Dim iTimeSec As Integer = 70
        Dim iTime As Integer = 50

        Select Case meMaskFormat
            Case ENUM_MASKFORMAT.REGISTERNUMBER
                MyBase.InputMask = "######-#######"
                Me.Size = New Size(iDateSize, Me.Size.Height)
            Case ENUM_MASKFORMAT.DATE
                MyBase.InputMask = "{LOC}yyyy/mm/dd"
                Me.Size = New Size(iDateSize, Me.Size.Height)
            Case ENUM_MASKFORMAT.DATETIME
                MyBase.InputMask = "{LOC}yyyy/mm/dd hh:mm"
                Me.Size = New Size(iDateTimeSize, Me.Size.Height)
            Case ENUM_MASKFORMAT.DATETIMESEC
                MyBase.InputMask = "{LOC}yyyy/mm/dd hh:mm:ss"
                Me.Size = New Size(iDateTimeSec, Me.Size.Height)
            Case ENUM_MASKFORMAT.TIMESEC
                MyBase.InputMask = "{LOC}hh:mm:ss"
                Me.Size = New Size(iTimeSec, Me.Size.Height)
            Case ENUM_MASKFORMAT.TIME
                MyBase.InputMask = "{LOC}hh:mm"
                Me.Size = New Size(iTime, Me.Size.Height)

        End Select

        NABiSetNullType(meUseNullType)

    End Sub

    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="peUseNullType"></param>
    ''' <remarks></remarks>
    Private Sub NABiSetNullType(peUseNullType As ENUM_TRUEFALSE)
        'If DesignMode Then

        Dim sNullText As String = ""

        If peUseNullType = ENUM_TRUEFALSE.TRUE Then
            'Null 허용 및 사용
            ' Me.Nullable = True
            Me.Appearance.ForeColor = Color.Silver

        ElseIf peUseNullType = ENUM_TRUEFALSE.FALSE Then
            'Null허용 안함
            ' Me.Nullable = False
            Me.Appearance.ForeColor = Color.Black

        End If

        'End If
    End Sub

#End Region

#Region " Public Methods "

    ''' <summary>
    ''' TextBox의 정렬과 읽기/쓰기 화면 설정
    ''' </summary>
    ''' <remarks>
    ''' 2015-06-18 민유진 Created
    ''' </remarks>
    Private Sub NABiSetTextBoxType()

        Select Case meTextBoxType
            Case ENUM_TEXTBOXTYPE.READ_LEFT, ENUM_TEXTBOXTYPE.READ_RIGHT, ENUM_TEXTBOXTYPE.READ_MIDDLE
                Me.ReadOnly = True
                Me.StyleLibraryName = "None"
                Me.UseOsThemes = Infragistics.Win.DefaultableBoolean.False
                Me.BorderStyle = Infragistics.Win.UIElementBorderStyle.Rounded1
                Me.Appearance.ForeColor = Color.FromArgb(100, 100, 100)
                Me.Appearance.BackColor = Color.FromArgb(235, 237, 238)
            Case ENUM_TEXTBOXTYPE.WRITE_LEFT, ENUM_TEXTBOXTYPE.WRITE_RIGHT, ENUM_TEXTBOXTYPE.WRITE_MIDDLE
                Me.ReadOnly = False
                If meUseNullType = ENUM_TRUEFALSE.TRUE Then
                    Me.Appearance.ForeColor = Color.Silver
                Else
                    Me.Appearance.ForeColor = Nothing
                End If

                Me.Appearance.BackColor = Nothing
                Me.StyleLibraryName = ""
        End Select

        Select Case meTextBoxType
            Case ENUM_TEXTBOXTYPE.READ_LEFT, ENUM_TEXTBOXTYPE.WRITE_LEFT
                Me.Appearance.TextHAlign = Infragistics.Win.HAlign.Left
            Case ENUM_TEXTBOXTYPE.READ_RIGHT, ENUM_TEXTBOXTYPE.WRITE_RIGHT
                Me.Appearance.TextHAlign = Infragistics.Win.HAlign.Right
            Case ENUM_TEXTBOXTYPE.READ_MIDDLE, ENUM_TEXTBOXTYPE.WRITE_MIDDLE
                Me.Appearance.TextHAlign = Infragistics.Win.HAlign.Center
        End Select

        Me.DisplayStyle = Infragistics.Win.EmbeddableElementDisplayStyle.Default

        If meTextBoxType = ENUM_TEXTBOXTYPE.NONE Then
            Me.StyleLibraryName = Nothing
        End If
    End Sub

    ''' <summary>
    ''' NABi Font Style 설정
    ''' </summary>
    ''' <param name="peFontStyle"></param>
    ''' <remarks></remarks>
    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle
        If peFontStyle = ENUM_TRUEFALSE.TRUE Then
            Me.Appearance.FontData.Name = NABI_FONTNAME
            Me.Appearance.FontData.SizeInPoints = NABI_MASKEDIT_FONTSIZE
        ElseIf peFontStyle = ENUM_TRUEFALSE.FALSE Then
            Me.Appearance.FontData.Name = Nothing
            Me.Appearance.FontData.SizeInPoints = Nothing
        End If
    End Sub

    Private Sub NABiMaskedEdit_ValueChanged(sender As Object, e As EventArgs) Handles Me.ValueChanged
        If meUseNullType = ENUM_TRUEFALSE.TRUE Then
            If Me.Text.Replace("-", "") = "" OrElse Me.Text.Replace(":", "") = "" Then
                Me.Appearance.ForeColor = Color.Silver
            Else
                Me.Appearance.ForeColor = Color.Black
            End If
        Else
            Me.Appearance.ForeColor = Color.Black
        End If
    End Sub

#End Region

End Class
