﻿Imports System.ComponentModel

Public Class NABiOptionSet
    Inherits Infragistics.Win.UltraWinEditors.UltraOptionSet
    Implements iNABiControlProperty


#Region " Private Fields "

    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meUseFontStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE

    ''NABi font
    'Private Const NABI_FONTSIZE As Single = 9
    'Private Const NABI_FONTNAME As String = "맑은 고딕"

#End Region

#Region " Properties "

    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi Option 스타일 설정")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle

        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value
            NABiSetOptionStyle()
            Me.Invalidate()
        End Set

    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("Font style 설정 (맑은고딕/9pt)")>
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle
        Get
            Return meUseFontStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseFontStyle = Value
            NABiSetFontStyle(meUseFontStyle)
            Me.Invalidate()
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

#End Region

#Region " Private Methods "

    ''' <summary>
    ''' NABi Style 설정
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub NABiSetOptionStyle()

        If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then
            Me.BorderStyle = Infragistics.Win.UIElementBorderStyle.None
        End If

    End Sub

    ' ''' <summary>
    ' ''' Font style 설정
    ' ''' </summary>
    ' ''' <remarks>
    ' ''' 2015-06-17 민유진 Created
    ' ''' </remarks>
    'Private Sub NABiSetOptionFontStyle(peUseOptionSetFontStyle As ENUM_TRUEFALSE)

    '    If peUseOptionSetFontStyle = ENUM_TRUEFALSE.TRUE Then
    '        Me.Appearance.FontData.Name = NABI_FONTNAME
    '        Me.Appearance.FontData.SizeInPoints = NABI_FONTSIZE
    '    ElseIf peUseOptionSetFontStyle = ENUM_TRUEFALSE.FALSE Then
    '        Me.Appearance.FontData.Name = Nothing
    '        Me.Appearance.FontData.SizeInPoints = Nothing
    '    End If

    'End Sub

    ''' <summary>
    ''' Font style 설정
    ''' 
    ''' </summary>
    ''' <param name="peFontStyle"></param>
    ''' <remarks></remarks>
    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle
        If peFontStyle = ENUM_TRUEFALSE.TRUE Then
            Me.Appearance.FontData.Name = NABI_FONTNAME
            Me.Appearance.FontData.SizeInPoints = NABI_FONTSIZE
        ElseIf peFontStyle = ENUM_TRUEFALSE.FALSE Then
            Me.Appearance.FontData.Name = Nothing
            Me.Appearance.FontData.SizeInPoints = Nothing
        End If
    End Sub

#End Region

    'Private Sub NABiOptionSet_Click(sender As Object, e As EventArgs) Handles Me.Click
    '    For iIndex As Integer = 0 To Me.Items.Count - 1
    '        If Me.Items(iIndex).CheckState = CheckState.Checked Then
    '            Me.Items(iIndex).Appearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True
    '        Else
    '            Me.Items(iIndex).Appearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.False
    '        End If
    '    Next

    'End Sub

    'Private Sub NABiOptionSet_ValueChanged(sender As Object, e As EventArgs) Handles Me.ValueChanged

    '    For iIndex As Integer = 0 To Me.Items.Count - 1
    '        If Me.Items(iIndex).CheckState = CheckState.Checked Then
    '            Me.Items(iIndex).Appearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True
    '        Else
    '            Me.Items(iIndex).Appearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.False
    '        End If
    '    Next



    'End Sub
End Class
