﻿Imports System.ComponentModel

Public Class NABiPanel
    Inherits Infragistics.Win.Misc.UltraPanel
    Implements iNABiControlProperty



#Region " Private Fields "

    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE

    Private mePanelType As ENUM_PANEL = ENUM_PANEL.NONE
    Private msTitleText As String = ""
    Private moTitleLabel As Infragistics.Win.Misc.UltraLabel
    'Private moPanelDock As ENUM_DOCK = ENUM_DOCK.NONE

#End Region

#Region " Properties "

    ''' <summary>
    ''' panel에 style 설정
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks>
    ''' 2015-06-17 민유진 Created
    ''' </remarks>
    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi Panel에 Style 설정")> _
    Public Property NABiPanelType() As ENUM_PANEL
        Get
            Return mePanelType
        End Get
        Set(ByVal Value As ENUM_PANEL)
            mePanelType = Value
            NABiSetPanelType()
            Invalidate()
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi style 사용 여부")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle
        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value
            NABiSetNABiStyle()
            Invalidate()
        End Set
    End Property

    ''' <summary>
    ''' Title 사용시 Title Text
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks>
    ''' 2015-06-17 민유진 Created
    ''' </remarks>
    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABiUseTitle 사용 시 Title Text 값")> _
    Public Property NABiPanelTitle() As String
        Get
            Return msTitleText
        End Get
        Set(value As String)
            msTitleText = value

            If moTitleLabel IsNot Nothing Then
                moTitleLabel.Text = msTitleText
            End If

            Me.Invalidate()
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("NABiUseTitle 사용 시 Title Visible 여부")> _
    Public Property NABiPanelTitleVisible() As Boolean
        Get
            If moTitleLabel IsNot Nothing Then
                Return moTitleLabel.Visible
            Else
                Return False
            End If
        End Get
        Set(value As Boolean)
            If moTitleLabel IsNot Nothing Then
                moTitleLabel.Visible = value
            End If

            Me.Invalidate()
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

    ' ''' <summary>
    ' ''' Title 사용시 Title Text
    ' ''' </summary>
    ' ''' <value></value>
    ' ''' <returns></returns>
    ' ''' <remarks>
    ' ''' 2015-06-17 민유진 Created
    ' ''' </remarks>
    '<CategoryAttribute("NABi Design"), Browsable(True), Description("Form 아래쪽 하단 버튼이 들어갈 Panel 설정")> _
    'Public Property NABiPanelDock() As ENUM_DOCK
    '    Get
    '        Return moPanelDock
    '    End Get
    '    Set(value As ENUM_DOCK)
    '        moPanelDock = value
    '        NABiPanelDocking(moPanelDock)
    '        Me.Invalidate()
    '    End Set
    'End Property

#End Region

#Region " Private Methods "

    ''' <summary>
    ''' Title성 Panel 사용시 디자인 정의
    ''' </summary>
    ''' <remarks>
    ''' 2015-06-17 민유진 Created
    ''' </remarks>
    Private Sub NABiSetPanelType()

        If mePanelType = ENUM_PANEL.TITLE Then

            moTitleLabel = New Infragistics.Win.Misc.UltraLabel

            moTitleLabel.Text = msTitleText
            moTitleLabel.Dock = System.Windows.Forms.DockStyle.Top
            moTitleLabel.Location = New System.Drawing.Point(0, 0)
            moTitleLabel.Name = "ifgLabelTitle"
            moTitleLabel.Size = New System.Drawing.Size(Me.Size.Width, 25)
            moTitleLabel.TabIndex = 0
            moTitleLabel.Appearance.BackColor = Color.AliceBlue

            moTitleLabel.Appearance.TextHAlign = Infragistics.Win.HAlign.Left
            moTitleLabel.Appearance.TextVAlign = Infragistics.Win.VAlign.Middle
            moTitleLabel.BorderStyleOuter = Infragistics.Win.UIElementBorderStyle.Rounded1

            moTitleLabel.Appearance.BackColor = Color.FromArgb(93, 126, 145)
            moTitleLabel.Appearance.BackColor2 = Color.FromArgb(137, 157, 168)
            moTitleLabel.Appearance.BorderColor = Color.White
            moTitleLabel.Appearance.BackGradientStyle = Infragistics.Win.GradientStyle.Horizontal

            moTitleLabel.Appearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True
            moTitleLabel.Appearance.ForeColor = Color.FromArgb(251, 255, 255)

            Me.Appearance.BackColor = Color.White
            Me.Appearance.BorderColor = Color.FromArgb(230, 230, 230)
            Me.BorderStyle = Infragistics.Win.UIElementBorderStyle.Rounded1
            Me.ClientArea.Controls.Add(moTitleLabel)

        ElseIf mePanelType = ENUM_PANEL.TOP Then
            Me.ClientArea.Controls.Remove(moTitleLabel)
            moTitleLabel = Nothing
            Me.Size = New Size(Me.Size.Width, 40)

        ElseIf mePanelType = ENUM_PANEL.BOTTOM Then
            Me.ClientArea.Controls.Remove(moTitleLabel)
            moTitleLabel = Nothing
            Me.Size = New Size(Me.Size.Width, 34)
            Me.Appearance.BackColor = Color.FromArgb(230, 230, 230)

        End If

    End Sub

    ''' <summary>
    ''' NABi Style 설정
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub NABiSetNABiStyle()

        If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then

            Me.Appearance.BackColor = Color.White
            Me.Appearance.BorderColor = Color.FromArgb(230, 230, 230)
            Me.BorderStyle = Infragistics.Win.UIElementBorderStyle.Rounded1

        ElseIf meUseNABiStyle = ENUM_TRUEFALSE.FALSE Then
            Me.BorderStyle = Infragistics.Win.UIElementBorderStyle.Default

        End If

    End Sub

    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle
        'Nothing
    End Sub

#End Region



End Class

