﻿Imports System.ComponentModel

Public Class NABiProgressBar
    Inherits Infragistics.Win.UltraWinProgressBar.UltraProgressBar
    Implements iNABiControlProperty

#Region " Private Fields "

    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meTextValueVisible As ENUM_TRUEFALSE = ENUM_TRUEFALSE.TRUE

    Protected Event Event_PropertyChanged(ByVal pRecreateHandle As Boolean)

#End Region

#Region " Constructors "

    Public Sub New()

        AddHandler Me.Event_PropertyChanged, AddressOf PropertyChanged
        RaiseEvent Event_PropertyChanged(False)

    End Sub

#End Region

#Region " Properties "

    ' ''' <summary>
    ' ''' ProgressBar Design 설정
    ' ''' </summary>
    ' ''' <value></value>
    ' ''' <returns></returns>
    ' ''' <remarks>
    ' ''' 2015-06-18 민유진 Created
    ' ''' </remarks>
    '<CategoryAttribute("NABi Design"), Browsable(True), Description("NABi 스타일 progressbar 설정")> _
    'Public Property NABiUseProgressbarStyle() As ENUM_TRUEFALSE

    '    Get
    '        Return meUseNABiStyle
    '    End Get
    '    Set(ByVal Value As ENUM_TRUEFALSE)
    '        meUseNABiStyle = Value
    '        NABiSetProgressbarStyle()
    '        PropertyChanged(True)
    '    End Set

    'End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi 스타일 progressbar 설정")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle

        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value
            NABiSetProgressbarStyle()
            PropertyChanged(True)
        End Set

    End Property

    ''' <summary>
    ''' ProgressBar Value값 Visible 여부
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks>
    ''' 2015-06-18 민유진 Created
    ''' </remarks>
    <CategoryAttribute("NABi Design"), Browsable(True), Description("progressbar value visible true/false")> _
    Public Property NABiTextValueVisible() As ENUM_TRUEFALSE

        Get
            Return meTextValueVisible
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meTextValueVisible = Value
            If meTextValueVisible = ENUM_TRUEFALSE.TRUE Then
                Me.TextVisible = True
            Else
                Me.TextVisible = False
            End If
            PropertyChanged(True)
        End Set

    End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

#End Region

#Region " Private Methods "

    ''' <summary>
    ''' ProgressBar Style 설정
    ''' </summary>
    ''' <remarks>
    ''' 2015-06-18 민유진 Created
    ''' </remarks>
    Private Sub NABiSetProgressbarStyle()

        If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then
            Me.Appearance.BackColor = Color.Transparent
            Me.Appearance.BackColor2 = Color.Transparent
            Me.Appearance.ImageBackground = My.Resources.progress_bg
            Me.FillAppearance.BackColor = Color.Transparent
            Me.FillAppearance.BackColor2 = Color.Transparent
            Me.FillAppearance.ImageBackground = My.Resources.progress_bar
            Me.BorderStyle = Infragistics.Win.UIElementBorderStyle.None
            Me.UseOsThemes = Infragistics.Win.DefaultableBoolean.False

        ElseIf meUseNABiStyle = ENUM_TRUEFALSE.FALSE Then
            Me.Appearance.BackColor = Nothing
            Me.Appearance.BackColor2 = Nothing
            Me.Appearance.ImageBackground = Nothing
            Me.FillAppearance.BackColor = Nothing
            Me.FillAppearance.BackColor2 = Nothing
            Me.FillAppearance.ImageBackground = Nothing
            Me.BorderStyle = Infragistics.Win.UIElementBorderStyle.Default

        End If

    End Sub

    ''' <summary>
    ''' Invalidate
    ''' </summary>
    ''' <param name="pRecreateHandle"></param>
    ''' <remarks>
    ''' 2015-06-18 민유진 Created
    ''' </remarks>
    Private Shadows Sub PropertyChanged(ByVal pRecreateHandle As Boolean)
        If (Not Me.Parent Is Nothing) Then
            'Dim _ControlRect As Rectangle = New Rectangle(Me.Location, Me.Size)
            'Me.Parent.Invalidate(_ControlRect, True)
        End If
        If (pRecreateHandle = True) Then Me.RecreateHandle()
        Me.Invalidate()
    End Sub

    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle
        'NOthing
    End Sub

#End Region

End Class
