﻿Imports System.ComponentModel
Imports Infragistics.Win.UltraWinToolbars

Public Class NABiRibbonToolbarMng
    Inherits Infragistics.Win.UltraWinToolbars.UltraToolbarsManager
    Implements iNABiControlProperty

#Region " Private Fields "

    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meUseCommonTabFix As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    'Private meSetRibbonTabImage As ENUM_TRUEFALSE = ENUM_TRUEFALSE.FALSE

    ' *** Control모두 Initalizing 되었는지 여부
    Private mbIsInitializing As Boolean = False

    ''리본 탭그룹 Fix 관련
    Private moRibbonGroupFix As RibbonGroup
    Private moRibbonTabFix As RibbonTab

#End Region

#Region " Properties "

    ' ''' <summary>
    ' ''' Ribbon Style 사용 여부
    ' ''' </summary>
    ' ''' <value></value>
    ' ''' <returns></returns>
    ' ''' <remarks></remarks>
    '<CategoryAttribute("NABi Design"), Browsable(True), Description("NABi 스타일 리본툴 설정")> _
    'Public Property NABiUseRibbonStyle() As ENUM_TRUEFALSE

    '    Get
    '        Return meUseNABiStyle
    '    End Get
    '    Set(ByVal Value As ENUM_TRUEFALSE)
    '        meUseNABiStyle = Value

    '        If (Not Me.mbIsInitializing) Then
    '            If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then
    '                NABiSetRibbonStyle()
    '            Else
    '                NABiClearRibbonStyle()
    '            End If
    '        End If

    '        InvalidateControls()
    '    End Set

    'End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi 스타일 리본툴 설정")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle
        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value

            If (Not Me.mbIsInitializing) Then
                If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then
                    NABiSetRibbonStyle()
                Else
                    'NABiClearRibbonStyle()
                End If
            End If

            InvalidateControls()
        End Set

    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi 스타일 리본툴 설정")>
    Public Property NABiUseCommonTabFix As ENUM_TRUEFALSE
        Get
            Return meUseCommonTabFix
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseCommonTabFix = Value
        End Set

    End Property


    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

#End Region

#Region " Protected Methods "

    ''' <summary>
    ''' control init 후
    ''' </summary>
    ''' <remarks>
    ''' 2015-06-24 민유진 Created
    ''' </remarks>
    Protected Overrides Sub OnBeginInit()
        Me.mbIsInitializing = True

        MyBase.OnBeginInit()

    End Sub

    ''' <summary>
    ''' Init 끝난 후 Ribbon Style 설정
    ''' </summary>
    ''' <remarks>
    ''' 2015-06-24 민유진 Created
    ''' </remarks>
    Protected Overrides Sub OnEndInit()
        MyBase.OnEndInit()

        Me.mbIsInitializing = False

        If Me.meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then
            NABiSetRibbonStyle()
            NABiSetRibbonDesign()
        End If
    End Sub

#End Region

#Region " Private Methods "

    ''' <summary>
    ''' Toolbar의 Ribbon 스타일 설정 
    ''' </summary>
    ''' <remarks>
    ''' 2015-06-22 민유진 Created
    ''' </remarks>
    Private Sub NABiSetRibbonStyle()

        If DesignMode Then

            Dim sButtonKey(2) As String
            Dim oButtonTool(2) As ButtonTool

            Dim sRibbonTabCaption() As String = {"기본", "조회", "출력", "설정"}
            Dim oRibbonKey(3) As String
            Dim oRibbonTab(3) As RibbonTab

            Dim oRibbonGroup1 As Infragistics.Win.UltraWinToolbars.RibbonGroup

            Try

                'Show Ribbon
                Me.Ribbon.Visible = True

                Me.LockToolbars = True
                Me.ShowQuickCustomizeButton = False

                ' *** Infragistics
                ' This is just quick and dirty. You probably want to check for the actual tabs
                ' by key using Me.Ribbon.Tabs.Exists(key)
                If (Me.Ribbon.Tabs.Count > 0) Then Return

                oRibbonGroup1 = New Infragistics.Win.UltraWinToolbars.RibbonGroup("nabiRibbonGroup1")
                oRibbonGroup1.Caption = "공통"

                ''첫번재 Ribbon Tab에 공통 Button 3개 설정
                For iIndex As Integer = 0 To sButtonKey.Count - 1

                    sButtonKey(iIndex) = "nabiButton" + iIndex.ToString
                    oButtonTool(iIndex) = New Infragistics.Win.UltraWinToolbars.ButtonTool(sButtonKey(iIndex))
                    oButtonTool(iIndex).SharedPropsInternal.Caption = sButtonKey(iIndex)
                    oButtonTool(iIndex).InstanceProps.MinimumSizeOnRibbon = Infragistics.Win.UltraWinToolbars.RibbonToolSize.Large
                    'Button 글자 색 지정
                    oButtonTool(iIndex).SharedProps.AppearancesLarge.Appearance.ForeColor = Color.White
                    oButtonTool(iIndex).SharedProps.AppearancesSmall.Appearance.ForeColor = Color.White

                    oRibbonGroup1.Tools.Add(oButtonTool(iIndex))

                Next

                'Ribbon 4개 Tab 설정
                For iIndex As Integer = 0 To oRibbonTab.Count - 1
                    'RibbonTab key가 이미 있으면 삭제한다.

                    oRibbonKey(iIndex) = "nabiRibbonTab" + iIndex.ToString

                    If Me.Ribbon.Tabs.Exists(oRibbonKey(iIndex)) Then
                        Me.Ribbon.Tabs.Remove(oRibbonKey(iIndex))
                    End If

                    oRibbonTab(iIndex) = New Infragistics.Win.UltraWinToolbars.RibbonTab(oRibbonKey(iIndex))
                    oRibbonTab(iIndex).Caption = sRibbonTabCaption(iIndex)

                    'Tab 글자 색 지정
                    oRibbonTab(iIndex).Settings.Appearance.ForeColor = Color.White
                Next

                'Ribbon Tab 이미지 설정
                oRibbonTab(0).Settings.Appearance.Image = My.Resources.basis    '기본
                oRibbonTab(1).Settings.Appearance.Image = My.Resources.search   '조회
                oRibbonTab(2).Settings.Appearance.Image = My.Resources.print    '출력
                oRibbonTab(3).Settings.Appearance.Image = My.Resources.setting  '설정

                oRibbonTab(0).Groups.AddRange(New Infragistics.Win.UltraWinToolbars.RibbonGroup() {oRibbonGroup1})


                If Not Me.Ribbon.Tabs.Exists(oRibbonTab(1).Key) Then
                    Me.Ribbon.Tabs.AddRange(New Infragistics.Win.UltraWinToolbars.RibbonTab() {oRibbonTab(0), oRibbonTab(1), oRibbonTab(2), oRibbonTab(3)})

                End If


            Catch ex As Exception
                MessageBox.Show(ex.ToString)
            End Try

        End If
    End Sub

    ''' <summary>
    ''' Ribbon Style 지정
    ''' </summary>
    ''' <remarks>
    ''' 2015-06-22 민유진 Created
    ''' </remarks>
    Private Sub NABiSetRibbonDesign()

        Try

            moRibbonTabFix = Me.Ribbon.Tabs(0)

            Me.CreationFilter = New CreatingUIElementCLS(ENUM_CONTROL.RIBBONTOOLBAR)

            'Tab 색 지정
            Me.Ribbon.TabSettings.Appearance.BackColor = Color.FromArgb(11, 116, 161)
            Me.Ribbon.TabSettings.Appearance.BackColor2 = Color.FromArgb(11, 110, 151)

            'Tab 헤더부분 색 지정
            Me.Ribbon.TabAreaAppearance.BackColor = Color.FromArgb(44, 45, 47)
            Me.Ribbon.TabAreaAppearance.BackColor2 = Color.FromArgb(42, 46, 47)
            Me.Ribbon.TabAreaAppearance.BackGradientStyle = Infragistics.Win.GradientStyle.Vertical

            'Disable 색 지정
            Me.Appearance.ForeColorDisabled = Color.DarkGray

            'Font Bold
            Me.Appearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True

            'Ribbon fontSize 고정
            Me.Ribbon.TabItemToolbar.Settings.Appearance.FontData.SizeInPoints = 8
            Me.Ribbon.GroupSettings.Appearance.FontData.SizeInPoints = 8
            Me.Ribbon.TabSettings.Appearance.FontData.SizeInPoints = 9

            Me.ImageSizeLarge = New Size(24, 24)

            NABiSetFixGroupDesign()

        Catch ex As Exception
            Throw ex
        End Try

    End Sub

    ''' <summary>
    ''' NABi Style 초기화 (원래상태)
    ''' </summary>
    ''' <remarks>
    ''' 2015-06-22 민유진 Created
    ''' </remarks>
    Private Sub NABiClearRibbonStyle()

        Me.Ribbon.Visible = False
        moRibbonGroupFix = Nothing

        'If Me.Ribbon.Tabs IsNot Nothing AndAlso Me.Ribbon.Tabs.Count > 0 Then
        '    'Tab 갯수만큼만 차례대로 삭제
        '    For iTabIndex As Integer = 0 To Me.Ribbon.Tabs.Count - 1

        '        If Me.Ribbon.Tabs(0).Groups.Count > 0 Then
        '            For iGroupIdx As Integer = 0 To Me.Ribbon.Tabs(0).Groups.Count - 1
        '                Me.Ribbon.Tabs(0).Groups.Remove(Me.Ribbon.Tabs(0).Groups(iGroupIdx).Key)
        '            Next
        '        End If
        '        Me.Ribbon.Tabs.Remove(Me.Ribbon.Tabs(0).Key)

        '    Next

        'End If

        For Each oTab As Infragistics.Win.UltraWinToolbars.RibbonTab In Me.Ribbon.Tabs
            For Each oGroup As Infragistics.Win.UltraWinToolbars.RibbonGroup In oTab.Groups
                oGroup.Tools.Clear()
            Next
            oTab.Groups.Clear()
        Next
        Me.Ribbon.Tabs.Clear()
        Me.Tools.Clear()

    End Sub

    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle
        'Nothing
    End Sub

#End Region

#Region " Public Methods "

    Public Sub NABiSetFixGroupDesign()
        'Ribbon Fix 그룹 설정 (첫번째 Tab에 첫번재 Group은 무조건 Fix)
        moRibbonGroupFix = Me.Ribbon.Tabs(0).Groups(0)

        If meUseCommonTabFix = ENUM_TRUEFALSE.TRUE Then

            '공통Ribbon그룹부분(Fix)만 색 다르게
            For Each oTool As Object In moRibbonGroupFix.Tools
                oTool.SharedProps.AppearancesLarge.Appearance.BackColor = Color.FromArgb(5, 72, 99)
                oTool.SharedProps.AppearancesLarge.Appearance.BackColor = Color.FromArgb(6, 89, 123)
                oTool.SharedProps.AppearancesLarge.Appearance.BackGradientStyle = Infragistics.Win.GradientStyle.Vertical
            Next

        End If

    End Sub

#End Region

#Region " Events "

#Region " Ribbon 공통 Tab group 고정 "

    ''' <summary>
    ''' Application menu 안나오게막는다..
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub NABiRibbonToolbarMng_BeforeApplicationMenuDropDown(sender As Object, e As CancelEventArgs) Handles Me.BeforeApplicationMenuDropDown
        e.Cancel = True
    End Sub

    ''' <summary>
    ''' 공통 GroupFix..
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2015-06-22 민유진 Created
    ''' </remarks>
    Private Sub NABiRibbonToolbarMng_BeforeRibbonTabSelected(sender As Object, e As BeforeRibbonTabSelectedEventArgs) Handles Me.BeforeRibbonTabSelected

        Try
            If DesignMode Then
                Return
            End If

            'Fix 그룹
            If moRibbonGroupFix Is Nothing Then Return

            If meUseCommonTabFix = ENUM_TRUEFALSE.TRUE Then
                NABiSetFixRibbonGroup(e.Tab)
            End If
        Catch ex As Exception
            MessageBox.Show(ex.ToString)
        End Try

    End Sub

    ''' <summary>
    ''' 공통 GroupFix.. Tab과 Group은 첫번째 항목을 Fix
    ''' </summary>
    ''' <remarks>
    ''' 2015-06-22 민유진 Created
    ''' </remarks>
    Private Sub NABiSetFixRibbonGroup(pRibbonTab As RibbonTab)
        Try
            ' Ribbon Fix Group 설정한다.
            If moRibbonTabFix.Groups.Contains(moRibbonGroupFix) Then
                moRibbonTabFix.Groups.Remove(moRibbonGroupFix)
            End If

            If pRibbonTab IsNot Nothing Then

                '첫번째 탭의 첫번째 그룹을 Fix 시킴
                pRibbonTab.Groups.Insert(0, moRibbonGroupFix)
                moRibbonTabFix = pRibbonTab
                pRibbonTab.Groups(0).Settings.Appearance.BackColor = System.Drawing.Color.FromArgb(6, 89, 123)

            End If

        Catch ex As Exception

            Throw

        End Try

    End Sub

#End Region

    Private Sub NABiRibbonToolbarMng_PropertyChanged(sender As Object, e As Infragistics.Win.PropertyChangedEventArgs) Handles Me.PropertyChanged
        Me.Ribbon.IsMinimized = False
    End Sub

#End Region

#Region " Custom Tool "

    Private Shared moToolFactory As ToolFactory = Nothing

    Friend Shared ReadOnly CUSTOMBUTTON_TOOLID As Guid = New Guid("66227453-9991-1019-ABC4-872BCDEF5411")
    Friend Shared ReadOnly CUSTOMCOMBOBOX_TOOLID As Guid = New Guid("66227453-9991-1019-ABC4-872BCDEF5412")

    Shared Sub New()
        moToolFactory = New ToolFactory()
    End Sub

    Private Class ToolFactory
        Implements IToolProvider

        Friend Sub New()
            Dim result As Boolean

            ' Register some custom tool types with UltraToolbarsManager.
            Try
                ' CustomButtonTool class.
                result = UltraToolbarsManager.RegisterCustomToolType(Me, CUSTOMBUTTON_TOOLID, "Custom Button", "CustomButtonTool")
                If result = False Then
                    MessageBox.Show("Error registering CustomButtonTool class!")
                End If

                ' CustomComboBoxTool class.
                result = UltraToolbarsManager.RegisterCustomToolType(Me, CUSTOMCOMBOBOX_TOOLID, "Custom ComboBox", "CustomComboBoxTool")
                If result = False Then
                    MessageBox.Show("Error registering CustomComboBoxTool class!")
                End If
            Catch
                'MessageBox.Show("Error registering custom tool classes!")
            End Try

        End Sub


        '/ <summary>
        '/ Creates and returns an instance of the tool identified by the specified GUID id.
        '/ </summary>
        '/ <param name="toolID">The Guid identifier specified for the tool when it was registered.</param>
        '/ <param name="key">The key assigned to the tool.</param>
        '/ <returns>A new instance of the specified tool.</returns>
        Function CreateToolInstance(ByVal toolID As Guid, ByVal key As String) As ToolBase Implements IToolProvider.CreateToolInstance
            If toolID.Equals(CUSTOMBUTTON_TOOLID) Then
                Return New ToolProvider.CustomButtonTool(key)
            End If

            If toolID.Equals(CUSTOMCOMBOBOX_TOOLID) Then
                Return New ToolProvider.CustomComboBoxTool(key)
            End If

            ' The tool ID is unknown to us so return null.
            Return Nothing

        End Function

    End Class

#End Region

End Class
