﻿Imports System.ComponentModel

Public Class NABiSplitter
    Inherits Infragistics.Win.Misc.UltraSplitter
    Implements iNABiControlProperty

#Region " Private Fields "
    
    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private Const miSplitterSize As Integer = 6

#End Region

#Region " Properties "

    <CategoryAttribute("NABi Design"), Browsable(True), Description("Splitter style 설정")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle
        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value
            If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then
                Me.AutoSize = False
                Me.Size = NABiSetSplitterSize()
            End If
            Invalidate()
        End Set

    End Property

    Protected Overrides ReadOnly Property DefaultSize As Size
        Get
            If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then
                Return NABiSetSplitterSize()
            End If
            Return MyBase.DefaultSize
        End Get
    End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle


    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

#End Region

#Region " Public Methods "

    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle
        'Nothing
    End Sub

    Private Function NABiSetSplitterSize() As Size

        Select Case Me.Dock
            Case DockStyle.Left, DockStyle.Right
                Return New Size(miSplitterSize, Me.Size.Height)
            Case DockStyle.Top, DockStyle.Bottom
                Return New Size(Me.Size.Width, miSplitterSize)
            Case Else
                Return Me.Size
        End Select

    End Function

#End Region

    Private Sub NABiSplitter_SizeChanged(sender As Object, e As EventArgs) Handles Me.SizeChanged

        If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then
            Return

        End If
    End Sub
End Class
