﻿Imports System.ComponentModel
Imports FarPoint.Win.Spread.FpSpread
Imports FarPoint.Win
Imports Infragistics.Win.Misc
Imports Infragistics.Win
Imports Infragistics.Win.UltraWinEditors
Imports FarPoint.Win.Spread

Public Class NABiSpread
    Inherits FarPoint.Win.Spread.FpSpread
    Implements iNABiControlProperty

#Region " Private Fields "

    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meRowHeaderVisible As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meColumnHeaderVisible As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meUseFontStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE


    Private moGridLine As New NABiSpreadGridLineCLS(Me)

    Private meUseSearch As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private mbIsShowSearchPanle As Boolean = False
    Private moSearchButton As UltraButton
    Private moSearchPanel As UltraPanel
    Private moSearchText As UltraTextEditor
    Private miFixedColumnIndex As Integer = -1

    Private moOrgInputMapFocused As InputMap
    Private moOrgInputMapAncestor As InputMap

#End Region

#Region " Properties "

    <CategoryAttribute("NABi Design"), Browsable(True), Description("Font style 설정 (맑은고딕/9pt)")>
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle
        Get
            Return meUseFontStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseFontStyle = Value
            NABiSetFontStyle(meUseFontStyle)
            Me.Invalidate()
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi 스타일 스프레드 설정")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle
        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value
            NABiSetSpreadStyle(meUseNABiStyle)
            Me.Invalidate()
        End Set

    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("Spread Row header visible")> _
    Public Property NABiRowHeaderVisible() As ENUM_TRUEFALSE

        Get
            Return meRowHeaderVisible
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meRowHeaderVisible = Value
            NABiSetRowHeaderVisible(meRowHeaderVisible)
            Me.Invalidate()
        End Set

    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("Spread Column header visible")> _
    Public Property NABiColumnHeaderVisible() As ENUM_TRUEFALSE

        Get
            Return meColumnHeaderVisible
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meColumnHeaderVisible = Value
            NABiSetColumnHeaderVisible(meColumnHeaderVisible)
            Me.Invalidate()
        End Set

    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("Spread Horizontal GridLine")> _
    Public Property NABiGridLine() As NABiSpreadGridLineCLS
        Get
            Return moGridLine
        End Get
        Set(ByVal Value As NABiSpreadGridLineCLS)
            moGridLine = Value
        End Set

    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("Spread 검색 기능 버튼 사용")> _
    Public Property NABiUseSearchButton() As ENUM_TRUEFALSE

        Get
            Return meUseSearch
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseSearch = Value
            If meUseSearch = ENUM_TRUEFALSE.TRUE Then
                NABiSetSearchButton()
            End If
        End Set

    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("Spread 고정 컬럼 index.   -1 인 경우 사용안함.  (ex. 3을 설정하면 왼쪽 0~3컬럼이 spread config 시 고정되고 수정 불가능함.)")> _
    Public Property NABiFixedColumnIndex() As Integer
        Get
            Return miFixedColumnIndex
        End Get
        Set(value As Integer)
            miFixedColumnIndex = value
        End Set
    End Property



    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

    ''' <summary>
    ''' 스프레드에서 SearchMode시 Key체크를 하기 위해
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public ReadOnly Property NABiGetSearchMode As Boolean
        Get
            Return mbIsShowSearchPanle And (moSearchText IsNot Nothing AndAlso moSearchText.Focused)
        End Get
    End Property

#End Region

#Region " Constructors "

    Public Sub New()

        'NABiSetInputMap으로 위치 변경
        ''Enter Key가 적용되도록 함
        'Dim oIM As InputMap
        'oIM = Me.GetInputMap(FarPoint.Win.Spread.InputMapMode.WhenAncestorOfFocused)
        'oIM.Put(New FarPoint.Win.Spread.Keystroke(Keys.Enter, Keys.None), FarPoint.Win.Spread.SpreadActions.None)

        ''Escape Key가 적용되도록 함 
        'oIM = Me.GetInputMap(FarPoint.Win.Spread.InputMapMode.WhenAncestorOfFocused)
        'oIM.Put(New FarPoint.Win.Spread.Keystroke(Keys.Escape, Keys.None), FarPoint.Win.Spread.SpreadActions.None)

    End Sub

#End Region

#Region " Private Methods "

    ''' <summary>
    ''' nabi style 스프레드설정
    ''' </summary>
    ''' <remarks>
    ''' 2015-06-17 민유진 Created
    ''' </remarks>
    Private Sub NABiSetSpreadStyle(ByVal peUseNabiStyle As ENUM_TRUEFALSE)

        Dim oEnhancedInterfaceRenderer As FarPoint.Win.Spread.EnhancedInterfaceRenderer = New FarPoint.Win.Spread.EnhancedInterfaceRenderer
        Dim oEnhancedColumnHeaderRenderer As FarPoint.Win.Spread.CellType.EnhancedColumnHeaderRenderer = New FarPoint.Win.Spread.CellType.EnhancedColumnHeaderRenderer
        Dim oEnhancedRowHeaderRenderer As FarPoint.Win.Spread.CellType.EnhancedRowHeaderRenderer = New FarPoint.Win.Spread.CellType.EnhancedRowHeaderRenderer


        If peUseNabiStyle = ENUM_TRUEFALSE.TRUE Then

            For Each oSheet As FarPoint.Win.Spread.SheetView In Me.Sheets

                With oSheet

                    'ColumnHeight 사이즈
                    If .ColumnHeader.Rows.Count > 0 Then
                        .ColumnHeader.Rows.Get(0).Height = 25.0!
                    End If

                    'Column Header 색상& 글꼴
                    .ColumnHeader.DefaultStyle.BackColor = System.Drawing.Color.FromArgb(235, 235, 235)
                    .ColumnHeader.DefaultStyle.ForeColor = System.Drawing.Color.FromArgb(122, 122, 122)

                    'Row Header 색상
                    .RowHeader.DefaultStyle.BackColor = System.Drawing.Color.FromArgb(235, 235, 235)
                    .RowHeader.DefaultStyle.ForeColor = System.Drawing.Color.FromArgb(122, 122, 122)

                    'Scrollbar는 AsNeeded
                    'Me.HorizontalScrollBarPolicy = FarPoint.Win.Spread.ScrollBarPolicy.AsNeeded
                    'Me.VerticalScrollBarPolicy = FarPoint.Win.Spread.ScrollBarPolicy.AsNeeded

                    'Spread 선색상
                    '.VerticalGridLine = New FarPoint.Win.Spread.GridLine(FarPoint.Win.Spread.GridLineType.Flat, System.Drawing.Color.FromArgb(196, 196, 196))
                    '.HorizontalGridLine = New FarPoint.Win.Spread.GridLine(FarPoint.Win.Spread.GridLineType.Flat, System.Drawing.Color.FromArgb(196, 196, 196))

                    'Scrollbar모양
                    Me.VerticalScrollBar.Renderer = Nothing
                    Me.HorizontalScrollBar.Renderer = Nothing
                    '.RowHeader.Visible = False

                    'ScrollBox Color 겹치는 부분
                    oEnhancedInterfaceRenderer.ScrollBoxBackgroundColor = System.Drawing.Color.FromArgb(221, 221, 221)
                    Me.InterfaceRenderer = oEnhancedInterfaceRenderer

                    'Column Header 선택 색상
                    oEnhancedColumnHeaderRenderer.SelectedBackgroundColor = System.Drawing.Color.FromArgb(210, 210, 210)
                    oEnhancedColumnHeaderRenderer.SelectedGridLineColor = System.Drawing.Color.FromArgb(210, 210, 210)
                    oEnhancedColumnHeaderRenderer.SelectedActiveBackgroundColor = System.Drawing.Color.FromArgb(210, 210, 210)
                    oEnhancedColumnHeaderRenderer.SelectedBackgroundColor = System.Drawing.Color.FromArgb(210, 210, 210)
                    oEnhancedColumnHeaderRenderer.SelectedGridLineColor = System.Drawing.Color.FromArgb(210, 210, 210)
                    .ColumnHeader.DefaultStyle.Renderer = oEnhancedColumnHeaderRenderer

                    'Row Header 선택 색상
                    oEnhancedRowHeaderRenderer.SelectedBackgroundColor = System.Drawing.Color.FromArgb(210, 210, 210)
                    oEnhancedRowHeaderRenderer.SelectedGridLineColor = System.Drawing.Color.FromArgb(210, 210, 210)
                    .RowHeader.DefaultStyle.Renderer = oEnhancedRowHeaderRenderer

                    'Corner 위쪽 색상
                    Me.Skin.CornerDefaultStyle.BackColor = System.Drawing.Color.FromArgb(235, 235, 235)

                    'Row Color
                    .AlternatingRows.Get(0).BackColor = System.Drawing.Color.White
                    .AlternatingRows.Get(1).BackColor = System.Drawing.Color.White
                    .RowHeader.DefaultStyle.BackColor = System.Drawing.Color.FromArgb(235, 235, 235)

                    'GrayArea색상 
                    .GrayAreaBackColor = Color.White

                    '선택 색상
                    .SelectionStyle = FarPoint.Win.Spread.SelectionStyles.SelectionColors
                    .SelectionBackColor = System.Drawing.Color.FromArgb(212, 235, 243)

                    Me.BorderStyle = Windows.Forms.BorderStyle.None

                End With

            Next

            Me.BackColor = System.Drawing.Color.White

        End If

        'Spread Font
    End Sub

    ''' <summary>
    ''' Row Header 보기 설정
    ''' </summary>
    ''' <param name="peRowHeaderVisible"></param>
    ''' <remarks></remarks>
    Private Sub NABiSetRowHeaderVisible(ByVal peRowHeaderVisible As ENUM_TRUEFALSE)

        If peRowHeaderVisible = ENUM_TRUEFALSE.TRUE Then

            If Me.Sheets.Count > 0 Then
                Me.Sheets(0).RowHeader.Visible = True
            End If
        Else
            If Me.Sheets.Count > 0 Then
                Me.Sheets(0).RowHeader.Visible = False
            End If
        End If

    End Sub

    ''' <summary>
    ''' Column Header 보기 설정
    ''' </summary>
    ''' <param name="peColumnHeaderVisible"></param>
    ''' <remarks></remarks>
    Private Sub NABiSetColumnHeaderVisible(ByVal peColumnHeaderVisible As ENUM_TRUEFALSE)

        If peColumnHeaderVisible = ENUM_TRUEFALSE.TRUE Then

            If Me.Sheets.Count > 0 Then
                Me.Sheets(0).ColumnHeader.Visible = True
            End If
        Else
            If Me.Sheets.Count > 0 Then
                Me.Sheets(0).ColumnHeader.Visible = False
            End If
        End If

    End Sub

    ''' <summary>
    ''' NABi Font 설정
    ''' </summary>
    ''' <param name="peFontStyle"></param>
    ''' <remarks></remarks>
    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle

        If meUseFontStyle = ENUM_TRUEFALSE.TRUE Then

            Me.Font = New Font(NABI_FONTNAME, NABI_FONTSIZE, FontStyle.Regular)

            For Each oSheet As FarPoint.Win.Spread.SheetView In Me.Sheets

                With oSheet

                    .ColumnHeader.DefaultStyle.Font = New Font(NABI_FONTNAME, NABI_FONTSIZE, FontStyle.Bold)

                End With

            Next

        End If

    End Sub

    ''' <summary>
    ''' 스프레드 검색 사용시 컨트롤 초기화
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub NABiSetSearchButton()

        If Not DesignMode AndAlso moSearchButton Is Nothing Then
            ''검색 버튼 생성
            moSearchButton = New UltraButton
            moSearchButton.Size = New Size(30, 30)
            moSearchButton.Appearance.Image = My.Resources.SpdSearch
            moSearchButton.Appearance.ImageVAlign = VAlign.Middle
            moSearchButton.Appearance.ImageHAlign = HAlign.Center
            moSearchButton.UseOsThemes = DefaultableBoolean.False
            moSearchButton.UseFlatMode = DefaultableBoolean.True
            moSearchButton.Appearance.BorderColor = Color.Silver
            moSearchButton.StyleLibraryName = "none"
            moSearchButton.BringToFront()
            moSearchButton.UseOsThemes = DefaultableBoolean.False
            moSearchButton.Visible = False

            AddHandler moSearchButton.Click, AddressOf EVENT_CLICK_SEARCHBUTTON
            AddHandler moSearchButton.MouseLeave, AddressOf EVENT_MOUSELEAVE_SEARCHBUTTON

            Me.Controls.Add(moSearchButton)

            ''Text Panel 생성
            moSearchPanel = New UltraPanel
            moSearchText = New UltraTextEditor
            moSearchPanel.Appearance.BorderColor = Color.Silver
            moSearchPanel.BorderStyle = UIElementBorderStyle.Inset
            moSearchPanel.UseOsThemes = DefaultableBoolean.False
            moSearchPanel.Size = New Size(160, 30)
            moSearchText.Size = New Size(150, 25)
            moSearchText.Location = New Point(4, 2)
            moSearchPanel.Visible = False
            moSearchText.Visible = False

            AddHandler moSearchText.KeyDown, AddressOf EVENT_KEYDOWN_SEARCHTEXTBOX
            AddHandler moSearchText.Leave, AddressOf EVENT_SEARCHTEXTBOX_LEAVE

            moSearchPanel.ClientArea.Controls.Add(moSearchText)
            Me.Controls.Add(moSearchPanel)

        End If
    End Sub

    ''' <summary>
    ''' Spread 검색
    ''' </summary>
    ''' <param name="psSearchStr"></param>
    ''' <remarks></remarks>
    Private Sub NABiSpreadSearch(ByVal psSearchStr As String)

        Dim iResultXPos As Integer
        Dim iResultYPos As Integer
        Dim bFound As Boolean = False

        Dim oSpd As FarPoint.Win.Spread.FpSpread
        Static sSearchStr As String
        Static iCurXPos As Integer
        Static iCurYPos As Integer

        If psSearchStr.Trim = "" Then
            Exit Sub
        End If

        If sSearchStr <> psSearchStr.Trim Then
            sSearchStr = psSearchStr.Trim
            iCurXPos = 0
            iCurYPos = 0
        End If

        oSpd = Me

        NABiSearchText(oSpd, sSearchStr, iCurXPos, iCurYPos, iResultXPos, iResultYPos, bFound)

        If bFound Then

            oSpd.ActiveSheet.SetActiveCell(iResultYPos, iResultXPos)
            oSpd.ActiveSheet.AddSelection(iResultYPos, iResultXPos, 1, 1)

            iCurXPos = iResultXPos + 1
            If iCurXPos > oSpd.Sheets(0).ColumnCount - 1 Then
                iCurXPos = 0
                iCurYPos = iResultYPos + 1
                If iCurYPos > oSpd.Sheets(0).RowCount - 1 Then
                    iCurYPos = 0
                End If
            Else
                iCurYPos = iResultYPos
            End If

            oSpd.ActiveSheet.ActiveRowIndex = iResultYPos
            oSpd.ShowCell(oSpd.GetActiveRowViewportIndex, oSpd.GetActiveColumnViewportIndex, iResultYPos, 0, VerticalPosition.Nearest, HorizontalPosition.Left)
            oSpd.ActiveSheet.AddSelection(iResultYPos, iResultXPos, 1, 1)

        Else
            'MsgBox("해당 검색조건을 찾을 수 없습니다.", MsgBoxStyle.Information, "확인")
        End If

    End Sub

    ''' <summary>
    ''' Spread 검색
    ''' </summary>
    ''' <param name="oPrmSpd"></param>
    ''' <param name="sPrmSearchStr"></param>
    ''' <param name="iPrmStrXPos"></param>
    ''' <param name="iPrmStrYPos"></param>
    ''' <param name="iPrmResultXPos"></param>
    ''' <param name="iPrmResultYPos"></param>
    ''' <param name="bPrmFound"></param>
    ''' <remarks></remarks>
    Private Sub NABiSearchText(ByVal oPrmSpd As FarPoint.Win.Spread.FpSpread, _
        ByVal sPrmSearchStr As String, _
        ByRef iPrmStrXPos As Integer, _
        ByRef iPrmStrYPos As Integer, _
        ByRef iPrmResultXPos As Integer, _
        ByRef iPrmResultYPos As Integer, _
        ByRef bPrmFound As Boolean)

        Dim bMustContinueFromTop As Boolean = False     '끝까지 다 검색하고 맨 윗줄부터 계속 검사할지 여부
        Dim iRow As Integer
        Dim iCol As Integer

        sPrmSearchStr = sPrmSearchStr.ToUpper

        If oPrmSpd.Sheets(0).RowCount <= 0 Then
            bPrmFound = False
            Exit Sub
        End If

        If iPrmStrXPos = 0 AndAlso iPrmStrYPos = 0 Then
            bMustContinueFromTop = False
        Else
            bMustContinueFromTop = True
        End If

        With oPrmSpd.Sheets(0)

            '검색 (iPrmStrXPos, iPrmStrYPos 부터 맨 아래까지)
            iCol = iPrmStrXPos
            For iRow = iPrmStrYPos To .RowCount - 1
                Do While iCol <= .ColumnCount - 1
                    If .Columns(iCol).Visible AndAlso .GetValue(iRow, iCol) IsNot Nothing _
                                             AndAlso InStr((.GetValue(iRow, iCol).ToString.Trim).ToUpper, sPrmSearchStr.ToUpper) > 0 Then
                        iPrmResultXPos = iCol
                        iPrmResultYPos = iRow
                        bPrmFound = True
                        Exit Sub
                    End If
                    iCol += 1
                Loop
                iCol = 0
            Next

            If bMustContinueFromTop Then
                '검색 (top row 부터 iPrmStrXPos, iPrmStrYPos까지)
                iCol = 0
                For iRow = 0 To iPrmStrYPos
                    Do While (iRow < iPrmStrYPos AndAlso iCol <= .ColumnCount - 1) OrElse (iRow = iPrmStrYPos AndAlso iCol <= iPrmStrXPos)
                        If .Columns(iCol).Visible AndAlso .GetValue(iRow, iCol) IsNot Nothing _
                                                AndAlso InStr((.GetValue(iRow, iCol).ToString.Trim).ToUpper, sPrmSearchStr.ToUpper) > 0 Then
                            iPrmResultXPos = iCol
                            iPrmResultYPos = iRow
                            bPrmFound = True
                            Exit Sub
                        End If
                        iCol += 1
                    Loop
                    iCol = 0
                Next
            End If

        End With

        bPrmFound = False

    End Sub

#End Region

#Region " Public Methods "

    ''' <summary>
    ''' 강제로 검색창을 종료시킨다
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub NABiStopSearchMode()
        EVENT_KEYDOWN_SEARCHTEXTBOX(moSearchText, New KeyEventArgs(Keys.Escape))
    End Sub

#End Region

#Region " Events "

    Private Sub NABiSpread_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown

        If meUseSearch = ENUM_TRUEFALSE.TRUE Then
            If Control.ModifierKeys And Keys.ControlKey = Keys.ControlKey And e.KeyCode = Keys.F Then
                If moSearchButton.Visible = False Then
                    If Me.VerticalScrollBar.Right = 0 OrElse Me.VerticalScrollBarPolicy = Spread.ScrollBarPolicy.Never Then
                        moSearchButton.Location = New Point(Me.ClientRectangle.Width - moSearchButton.Size.Width, Me.ClientRectangle.Top)
                    Else
                        moSearchButton.Location = New Point(Me.ClientRectangle.Width - moSearchButton.Size.Width - SystemInformation.VerticalScrollBarWidth, Me.ClientRectangle.Top)
                    End If
                    moSearchButton.Visible = True
                End If

                If Not mbIsShowSearchPanle Then
                    NABiShowSearchPanel()
                Else
                    moSearchText.Focus()
                End If

            End If
        End If

    End Sub

    ''' <summary>
    ''' 마우스가 스프레드 영역을 벗어나면 검색버튼 숨김
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub NABiSpread_MouseLeave(sender As Object, e As EventArgs) Handles Me.MouseLeave
        Try
            If meUseSearch = ENUM_TRUEFALSE.TRUE Then
                If mbIsShowSearchPanle = False AndAlso _
                   Not Me.ClientRectangle.Contains(PointToClient(Control.MousePosition)) Then
                    moSearchButton.Visible = False
                End If
            End If

        Catch ex As Exception
            moSearchButton.Visible = False
            moSearchPanel.Visible = False
            moSearchText.Visible = False
            mbIsShowSearchPanle = False
        End Try
    End Sub


    ''' <summary>
    ''' 스프레드 검색 사용시 버튼 추가
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub NABiSpread_MouseMove(sender As Object, e As MouseEventArgs) Handles Me.MouseMove

        Try
            If meUseSearch = ENUM_TRUEFALSE.TRUE Then

                Dim oColumnHeader As Rectangle = Me.GetColumnHeaderRectangle(0)
                Dim oArea As Point = New Point(e.X, e.Y)

                If oColumnHeader.Contains(oArea) Then

                    If moSearchButton.Visible = False Then
                        If Me.VerticalScrollBar.Right = 0 OrElse Me.VerticalScrollBarPolicy = Spread.ScrollBarPolicy.Never Then
                            moSearchButton.Location = New Point(Me.ClientRectangle.Width - moSearchButton.Size.Width, Me.ClientRectangle.Top)
                        Else
                            moSearchButton.Location = New Point(Me.ClientRectangle.Width - moSearchButton.Size.Width - SystemInformation.VerticalScrollBarWidth, Me.ClientRectangle.Top)
                        End If
                        moSearchButton.Visible = True
                    End If

                Else
                    If Not mbIsShowSearchPanle Then
                        moSearchButton.Visible = False
                    End If
                End If

            End If

        Catch ex As Exception
            moSearchButton.Visible = False
            moSearchPanel.Visible = False
            moSearchText.Visible = False
            mbIsShowSearchPanle = False
        End Try
    End Sub


    ''' <summary>
    '''  검색 버튼 Click
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub EVENT_CLICK_SEARCHBUTTON(sender As Object, e As EventArgs)

        Try
            If mbIsShowSearchPanle Then
                NABiHideSearchPanel()
            Else
                NABiShowSearchPanel()
            End If

        Catch ex As Exception
            moSearchButton.Visible = False
            moSearchPanel.Visible = False
            moSearchText.Visible = False
            mbIsShowSearchPanle = False
        End Try

    End Sub

    Private Sub NABiShowSearchPanel()
        If meUseSearch = ENUM_TRUEFALSE.TRUE Then
            If mbIsShowSearchPanle = False Then
                moSearchPanel.Location = New Point(moSearchButton.Location.X - moSearchPanel.Size.Width, moSearchButton.Location.Y)
                moSearchPanel.Visible = True
                moSearchText.Visible = True
                moSearchText.Focus()
                moSearchPanel.BringToFront()
                mbIsShowSearchPanle = True

                NABiSetInputMap(True)
            End If
        End If

    End Sub

    Private Sub NABiHideSearchPanel()
        If meUseSearch = ENUM_TRUEFALSE.TRUE Then
            moSearchPanel.Visible = False
            moSearchText.Visible = False
            mbIsShowSearchPanle = False

            NABiSetInputMap(False)
        End If
    End Sub

    ''' <summary>
    ''' TextBox 검색
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub EVENT_KEYDOWN_SEARCHTEXTBOX(sender As Object, e As KeyEventArgs)

        If e.KeyCode = Keys.Enter OrElse e.KeyCode = Keys.Return OrElse e.KeyCode = Keys.F3 Then

            NABiSpreadSearch(moSearchText.Text.Trim)

        ElseIf e.KeyCode = Keys.Escape Then

            moSearchButton.Visible = False
            NABiHideSearchPanel()

            Me.Focus()
        End If

    End Sub

    Private Sub EVENT_MOUSELEAVE_SEARCHBUTTON(sender As Object, e As EventArgs)

        Try
            If meUseSearch = ENUM_TRUEFALSE.TRUE Then
                If mbIsShowSearchPanle = False Then
                    moSearchButton.Visible = False
                End If
            End If
        Catch ex As Exception
            moSearchButton.Visible = False
            moSearchPanel.Visible = False
            moSearchText.Visible = False
            mbIsShowSearchPanle = False
        End Try

    End Sub

    Private Sub EVENT_SEARCHTEXTBOX_LEAVE(sender As Object, e As EventArgs)

        If meUseSearch = ENUM_TRUEFALSE.TRUE Then
            If mbIsShowSearchPanle = True Then
                moSearchButton.Visible = False
                NABiHideSearchPanel()
            End If
        End If

    End Sub

    Private Sub NABiSetInputMap(ByVal pbSearchMode As Boolean)

        If pbSearchMode Then

            '원래 Inputmap설정을 가지고 있는다.
            moOrgInputMapFocused = Me.GetInputMap(InputMapMode.WhenFocused)
            moOrgInputMapAncestor = Me.GetInputMap(InputMapMode.WhenAncestorOfFocused)

            'Enter Key가 적용되도록 함
            Dim oInputMap As InputMap
            oInputMap = Me.GetInputMap(FarPoint.Win.Spread.InputMapMode.WhenAncestorOfFocused)
            oInputMap.Put(New FarPoint.Win.Spread.Keystroke(Keys.Enter, Keys.None), FarPoint.Win.Spread.SpreadActions.None)

            'Escape Key가 적용되도록 함 
            oInputMap = Me.GetInputMap(FarPoint.Win.Spread.InputMapMode.WhenAncestorOfFocused)
            oInputMap.Put(New FarPoint.Win.Spread.Keystroke(Keys.Escape, Keys.None), FarPoint.Win.Spread.SpreadActions.None)

            'F3 Key
            oInputMap = Me.GetInputMap(FarPoint.Win.Spread.InputMapMode.WhenAncestorOfFocused)
            oInputMap.Put(New FarPoint.Win.Spread.Keystroke(Keys.F3, Keys.None), FarPoint.Win.Spread.SpreadActions.None)

        Else
            If moOrgInputMapAncestor IsNot Nothing Then
                Dim oKeystroke As Keystroke
                Dim oInputMap As InputMap
                Dim oValue As Object

                For Each oKeystroke In moOrgInputMapAncestor.Keys
                    '원래 Enter Key, Escape Key의 기능으로 적용되도록 함 
                    Select Case oKeystroke.KeyCode
                        Case Keys.Enter

                            oValue = moOrgInputMapAncestor.Get(oKeystroke)
                            oInputMap = Me.GetInputMap(FarPoint.Win.Spread.InputMapMode.WhenAncestorOfFocused)
                            oInputMap.Remove(New FarPoint.Win.Spread.Keystroke(Keys.Enter, Keys.None))
                            oInputMap.Put(New FarPoint.Win.Spread.Keystroke(oKeystroke.KeyCode, oKeystroke.Modifiers), oValue.ToString)

                        Case Keys.Escape

                            oValue = moOrgInputMapAncestor.Get(oKeystroke)
                            oInputMap = Me.GetInputMap(FarPoint.Win.Spread.InputMapMode.WhenAncestorOfFocused)
                            oInputMap.Remove(New FarPoint.Win.Spread.Keystroke(Keys.Escape, Keys.None))
                            oInputMap.Put(New FarPoint.Win.Spread.Keystroke(oKeystroke.KeyCode, oKeystroke.Modifiers), oValue.ToString)

                        Case Keys.F3

                            oValue = moOrgInputMapAncestor.Get(oKeystroke)
                            oInputMap = Me.GetInputMap(FarPoint.Win.Spread.InputMapMode.WhenAncestorOfFocused)
                            oInputMap.Remove(New FarPoint.Win.Spread.Keystroke(Keys.F3, Keys.None))
                            oInputMap.Put(New FarPoint.Win.Spread.Keystroke(oKeystroke.KeyCode, oKeystroke.Modifiers), oValue.ToString)

                    End Select

                Next
            End If

        End If

    End Sub

#End Region

End Class

#Region " Spread GridLine Expandable Class "

<TypeConverter(GetType(ExpandableObjectConverter)), Description("NABiSpreadGridLine")> _
Public Class NABiSpreadGridLineCLS
    Inherits ExpandableObjectConverter


    Private meVerticalGridLine As ENUM_SPDGRIDLINE = ENUM_SPDGRIDLINE.DEFAULT
    Private meHorizontalGridLine As ENUM_SPDGRIDLINE = ENUM_SPDGRIDLINE.DEFAULT
    Private moSpread As FarPoint.Win.Spread.FpSpread

    Public Sub New(ByVal poSpread As FarPoint.Win.Spread.FpSpread)
        moSpread = poSpread
    End Sub

    <DescriptionAttribute("Spread Vertical GridLine")> _
    Public Property NABiVerticalGridLine() As ENUM_SPDGRIDLINE
        Get
            Return meVerticalGridLine
        End Get
        Set(ByVal Value As ENUM_SPDGRIDLINE)
            meVerticalGridLine = Value
            NABiSetGridLine(meVerticalGridLine, True)
            moSpread.Invalidate()
        End Set

    End Property

    <DescriptionAttribute("Spread Horizontal GridLine")> _
    Public Property NABiHorizontalGridLine() As ENUM_SPDGRIDLINE
        Get
            Return meHorizontalGridLine
        End Get
        Set(ByVal Value As ENUM_SPDGRIDLINE)
            meHorizontalGridLine = Value
            NABiSetGridLine(meHorizontalGridLine, False)
            moSpread.Invalidate()
        End Set

    End Property

    Public Overrides Function ToString() As String
        Return "V : " & NABiVerticalGridLine.ToString & ", H : " & NABiHorizontalGridLine.ToString
    End Function

    Private Sub NABiSetGridLine(ByVal peGridLine As ENUM_SPDGRIDLINE, ByVal pbIsVertical As Boolean)

        For Each oSheet As FarPoint.Win.Spread.SheetView In moSpread.Sheets

            Select Case peGridLine
                Case ENUM_SPDGRIDLINE.DEFAULT
                    If pbIsVertical Then
                        oSheet.VerticalGridLine = New FarPoint.Win.Spread.GridLine(Spread.GridLineType.Flat)
                    Else
                        oSheet.HorizontalGridLine = New FarPoint.Win.Spread.GridLine(Spread.GridLineType.Flat)
                    End If

                Case ENUM_SPDGRIDLINE.NONE
                    If pbIsVertical Then
                        oSheet.VerticalGridLine = New FarPoint.Win.Spread.GridLine(Spread.GridLineType.None)
                    Else
                        oSheet.HorizontalGridLine = New FarPoint.Win.Spread.GridLine(Spread.GridLineType.None)
                    End If

            End Select
        Next

    End Sub

End Class

#End Region