﻿Imports System.ComponentModel

Public Class NABiTabControl
    Inherits Infragistics.Win.UltraWinTabControl.UltraTabControl
    Implements iNABiControlProperty

#Region " Private Fields "

    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meUseFontStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE

    ''NABi font
    'Private Const NABI_FONTSIZE As Single = 9
    'Private Const NABI_FONTNAME As String = "맑은 고딕"

#End Region

#Region " Properties "

    ' ''' <summary>
    ' ''' Tab Font style 자동 조절
    ' ''' </summary>
    ' ''' <value></value>
    ' ''' <returns></returns>
    ' ''' <remarks>
    ' ''' 2015-06-17 민유진 Created
    ' ''' </remarks>
    '<CategoryAttribute("NABi Design"), Browsable(True), Description("Tab font style 설정 (맑은고딕/9pt)")> _
    'Public Property NABiUseFontStyle() As ENUM_TRUEFALSE
    '    Get
    '        Return meUseTabFontStyle
    '    End Get
    '    Set(ByVal Value As ENUM_TRUEFALSE)
    '        meUseTabFontStyle = Value
    '        NABiSetTabFontStyle(meUseTabFontStyle)
    '        Me.Invalidate()
    '    End Set
    'End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("Tab font style 설정 (맑은고딕/9pt)")>
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle
        Get
            Return meUseFontStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseFontStyle = Value
            NABiSetFontStyle(meUseFontStyle)
            Me.Invalidate()
        End Set
    End Property

    ' ''' <summary>
    ' ''' NABi Tab 스타일 사용여부
    ' ''' </summary>
    ' ''' <value></value>
    ' ''' <returns></returns>
    ' ''' <remarks>
    ' ''' 2015-06-17 민유진 Created
    ' ''' </remarks>
    '<CategoryAttribute("NABi Design"), Browsable(True), Description("Nabi Tab style 사용 여부")> _
    'Public Property NABiUseTabStyle() As ENUM_TRUEFALSE
    '    Get
    '        Return meUseTabStyle
    '    End Get
    '    Set(ByVal Value As ENUM_TRUEFALSE)
    '        meUseTabStyle = Value
    '        NABiSetTabStyle()
    '        Me.Invalidate()
    '    End Set
    'End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("Nabi Tab style 사용 여부")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle
        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value
            NABiSetTabStyle()
            Me.Invalidate()
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

#End Region

#Region " Private Methods "

    ''' <summary>
    ''' NABi에서 사용되는 Tab Style지정
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub NABiSetTabStyle()

        If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then
            'Tab사이 간격
            Me.InterTabSpacing = 2
            Me.Style = Infragistics.Win.UltraWinTabControl.UltraTabControlStyle.VisualStudio2005

        ElseIf meUseNABiStyle = ENUM_TRUEFALSE.FALSE Then
            Me.Style = Infragistics.Win.UltraWinTabControl.UltraTabControlStyle.Default
            Me.InterTabSpacing = Nothing

        End If

    End Sub

    ' ''' <summary>
    ' ''' Font style 설정
    ' ''' </summary>
    ' ''' <remarks>
    ' ''' 2015-06-23 민유진 Created
    ' ''' </remarks>
    'Private Sub NABiSetTabFontStyle(peUseTabFontStyle As ENUM_TRUEFALSE)
    '    If peUseTabFontStyle = ENUM_TRUEFALSE.TRUE Then
    '        Me.Appearance.FontData.Name = NABI_FONTNAME
    '        Me.Appearance.FontData.SizeInPoints = NABI_FONTSIZE
    '    ElseIf peUseTabFontStyle = ENUM_TRUEFALSE.FALSE Then
    '        Me.Appearance.FontData.Name = Nothing
    '        Me.Appearance.FontData.SizeInPoints = Nothing
    '    End If
    'End Sub

    ''' <summary>
    ''' Font style 설정
    ''' </summary>
    ''' <param name="peFontStyle"></param>
    ''' <remarks></remarks>
    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle
        If peFontStyle = ENUM_TRUEFALSE.TRUE Then
            Me.Appearance.FontData.Name = NABI_FONTNAME
            Me.Appearance.FontData.SizeInPoints = NABI_FONTSIZE
        End If
    End Sub

#End Region


End Class
