﻿Imports System.ComponentModel

Public Class NABiTabbedMdiManager
    Inherits Infragistics.Win.UltraWinTabbedMdi.UltraTabbedMdiManager
    Implements iNABiControlProperty


#Region " Private Fields "

    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meUseFontStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE

#End Region

#Region " Properties "

    <CategoryAttribute("NABi Design"), Browsable(True), Description("Tab font style 설정 (맑은고딕/9pt)")>
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle
        Get
            Return meUseFontStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseFontStyle = Value
            NABiSetFontStyle(meUseFontStyle)
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("Nabi Tab MDI style 사용 여부")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle
        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value
            NABiSetNABiStyle()
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

#End Region

#Region " Public Methods "

    ''' <summary>
    ''' Font Style 설정
    ''' </summary>
    ''' <param name="peFontStyle"></param>
    ''' <remarks></remarks>
    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle
        If peFontStyle = ENUM_TRUEFALSE.TRUE Then
            Me.Appearance.FontData.Name = NABI_FONTNAME
            Me.Appearance.FontData.SizeInPoints = NABI_FONTSIZE
            Me.TabSettings.ActiveTabAppearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True
            Me.TabSettings.ActiveTabAppearance.ForeColor = Color.FromArgb(50, 50, 50)
            Me.TabSettings.SelectedTabAppearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True
            Me.TabSettings.SelectedTabAppearance.ForeColor = Color.FromArgb(122, 122, 122)

        End If
    End Sub

#End Region

#Region " Private Methods "

    ''' <summary>
    ''' NABiStyle 설정
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub NABiSetNABiStyle()
        If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then
            'Tab사이 간격
            Me.TabGroupSettings.InterTabSpacing = 2
            Me.TabGroupSettings.TabStyle = Infragistics.Win.UltraWinTabs.TabStyle.VisualStudio2005

            Me.TabSettings.HotTrack = Infragistics.Win.DefaultableBoolean.True

            Me.TabSettings.ActiveTabAppearance.BackColor = Color.FromArgb(224, 224, 224)
            Me.TabSettings.ActiveTabAppearance.BackColor2 = Color.White
            Me.TabSettings.ActiveTabAppearance.BackGradientStyle = Infragistics.Win.GradientStyle.Vertical
            Me.TabSettings.HotTrackTabAppearance.BackColor = Color.FromArgb(224, 224, 224)
            Me.TabSettings.HotTrackTabAppearance.BackColor2 = Color.White
            Me.TabSettings.HotTrackTabAppearance.BackGradientStyle = Infragistics.Win.GradientStyle.Vertical
            Me.TabSettings.SelectedTabAppearance.BackColor = Color.FromArgb(224, 224, 224)
            Me.TabSettings.SelectedTabAppearance.BackColor2 = Color.White
            Me.TabSettings.SelectedTabAppearance.BackGradientStyle = Infragistics.Win.GradientStyle.Vertical
            Me.TabSettings.TabAppearance.BackColor = Color.FromArgb(214, 214, 214)
            Me.TabSettings.TabAppearance.BackColor2 = Color.FromArgb(196, 196, 196)
            Me.TabSettings.TabAppearance.BackGradientStyle = Infragistics.Win.GradientStyle.Vertical

            Me.Appearance.BackColor = Color.White
        End If
    End Sub

#End Region

End Class
