﻿Imports System.ComponentModel

Public Class NABiTextBox
    Inherits Infragistics.Win.UltraWinEditors.UltraTextEditor
    Implements iNABiControlProperty

#Region " Private Fields "

    Private meTextBoxType As ENUM_TEXTBOXTYPE = ENUM_TEXTBOXTYPE.WRITE_LEFT
    Private meDataType As ENUM_PROTECTDATA = ENUM_PROTECTDATA.NONE
    Private meDataProtect As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meUseFontStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE

    Private meTextBoxImageType As ENUM_IMAGETYPE = ENUM_IMAGETYPE.NONE

#End Region

#Region " Properties "

    <CategoryAttribute("NABi Design"), Browsable(True), Description("Font style 설정 (맑은고딕/9pt)")>
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle
        Get
            Return meUseFontStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseFontStyle = Value
            NABiSetFontStyle(meUseFontStyle)
            Me.Invalidate()
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi Option 스타일 설정")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle

        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value
            NABiSetNABiStyle()
            Me.Invalidate()
        End Set

    End Property

    ''' <summary>
    ''' TextBox 정렬및 읽기/쓰기용 선택
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <CategoryAttribute("NABi Design"), Browsable(True), Description("TextBox 정렬및 읽기/쓰기용 선택")> _
    Public Property NABiTextBoxType() As ENUM_TEXTBOXTYPE
        Get
            Return meTextBoxType
        End Get
        Set(ByVal Value As ENUM_TEXTBOXTYPE)
            meTextBoxType = Value
                NABiSetTextBoxType()
            Me.Invalidate()
        End Set
    End Property

    ''' <summary>
    ''' TextBox 이미지 타입 Help, Search
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <CategoryAttribute("NABi Design"), Browsable(True), Description("TextBox 이미지 타입 Help, Search 선택")> _
    Public Property NABiImageType() As ENUM_IMAGETYPE
        Get
            Return meTextBoxImageType
        End Get
        Set(ByVal Value As ENUM_IMAGETYPE)
            meTextBoxImageType = Value
            NABiSetTextBoxImage()
            Me.Invalidate()
        End Set
    End Property


    ' ''' <summary>
    ' ''' NABiTextBoxData에 보안 설정 종류
    ' ''' </summary>
    ' ''' <value></value>
    ' ''' <returns></returns>
    ' ''' <remarks>
    ' ''' 2015-06-18 민유진 Created
    ' ''' </remarks>
    '<CategoryAttribute("NABi Design"), Browsable(True), Description("TextBox 보안 설정 데이터")> _
    'Public Property NABiDataType() As ENUM_PROTECTDATA
    '    Get
    '        Return meDataType
    '    End Get
    '    Set(ByVal Value As ENUM_PROTECTDATA)
    '        meDataType = Value
    '        Me.Invalidate()
    '    End Set
    'End Property


    <CategoryAttribute("NABi Design"), Browsable(True), Description("TextBox 보안 설정 데이터")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType
        Get
            Return meDataType
        End Get
        Set(ByVal Value As ENUM_PROTECTDATA)
            meDataType = Value
            Me.Invalidate()
        End Set
    End Property


    <CategoryAttribute("NABi Design"), Browsable(True), Description("TextBox 보안 설정 여부")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect
        Get
            Return meDataProtect
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meDataProtect = Value
            Me.Invalidate()
        End Set
    End Property

    ' ''' <summary>
    ' ''' NABiDataType에 따른 보안 설정 여부
    ' ''' </summary>
    ' ''' <value></value>
    ' ''' <returns></returns>
    ' ''' <remarks>
    ' ''' 2015-06-18 민유진 Created
    ' ''' </remarks>
    '<CategoryAttribute("NABi Design"), Browsable(True), Description("TextBox 보안 설정 여부")> _
    'Public Property NABiDataProtect() As ENUM_TRUEFALSE
    '    Get
    '        Return meDataProtect
    '    End Get
    '    Set(ByVal Value As ENUM_TRUEFALSE)
    '        meDataProtect = Value
    '        Me.Invalidate()
    '    End Set
    'End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster


#End Region

#Region " Private Methods "

    ''' <summary>
    ''' TextBox의 정렬과 읽기/쓰기 화면 설정
    ''' </summary>
    ''' <remarks>
    ''' 2015-06-18 민유진 Created
    ''' </remarks>
    Private Sub NABiSetTextBoxType()

        Select Case meTextBoxType
            Case ENUM_TEXTBOXTYPE.READ_LEFT, ENUM_TEXTBOXTYPE.READ_RIGHT, ENUM_TEXTBOXTYPE.READ_MIDDLE
                Me.ReadOnly = True
                Me.StyleLibraryName = "None"
                Me.UseOsThemes = Infragistics.Win.DefaultableBoolean.False
                Me.BorderStyle = Infragistics.Win.UIElementBorderStyle.Rounded1
                Me.Appearance.ForeColor = Color.FromArgb(100, 100, 100)
                Me.Appearance.BackColor = Color.FromArgb(235, 237, 238)
            Case ENUM_TEXTBOXTYPE.WRITE_LEFT, ENUM_TEXTBOXTYPE.WRITE_RIGHT, ENUM_TEXTBOXTYPE.WRITE_MIDDLE
                Me.ReadOnly = False
                Me.Appearance.ForeColor = Nothing
                Me.Appearance.BackColor = Nothing
                Me.StyleLibraryName = ""
        End Select

        Select Case meTextBoxType
            Case ENUM_TEXTBOXTYPE.READ_LEFT, ENUM_TEXTBOXTYPE.WRITE_LEFT
                Me.Appearance.TextHAlign = Infragistics.Win.HAlign.Left
            Case ENUM_TEXTBOXTYPE.READ_RIGHT, ENUM_TEXTBOXTYPE.WRITE_RIGHT
                Me.Appearance.TextHAlign = Infragistics.Win.HAlign.Right
            Case ENUM_TEXTBOXTYPE.READ_MIDDLE, ENUM_TEXTBOXTYPE.WRITE_MIDDLE
                Me.Appearance.TextHAlign = Infragistics.Win.HAlign.Center
        End Select

        Me.DisplayStyle = Infragistics.Win.EmbeddableElementDisplayStyle.Default

        If meTextBoxType = ENUM_TEXTBOXTYPE.NONE Then
            Me.StyleLibraryName = Nothing
        End If
    End Sub

    ''' <summary>
    ''' TextImageType에 따른 Image 설정
    ''' </summary>
    ''' <remarks>
    ''' 2015-07-09 민유진 Created
    ''' </remarks>
    Private Sub NABiSetTextBoxImage()

        Select Case meTextBoxImageType

            Case ENUM_IMAGETYPE.HELP, ENUM_IMAGETYPE.SEARCH
                AddHandler Me.AfterEnterEditMode, AddressOf NABiTextBoxFocusIn
                AddHandler Me.AfterExitEditMode, AddressOf NABiTextBoxFocusOut

            Case Else
                RemoveHandler Me.AfterEnterEditMode, AddressOf NABiTextBoxFocusIn
                RemoveHandler Me.AfterExitEditMode, AddressOf NABiTextBoxFocusOut

        End Select

    End Sub

    ''' <summary>
    ''' TextBox에Foocus가 왔을 때 ImageType에 따른 Image 설정
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2015-07-09 민유진 Created
    ''' </remarks>
    Private Sub NABiTextBoxFocusIn(sender As Object, e As EventArgs)

        If meTextBoxImageType = ENUM_IMAGETYPE.HELP Then
            '이미지를 Runtime시 입히면 size가 작아져서 AutoSize는 False시킴.
            Me.AutoSize = False
            Me.Appearance.Image = My.Resources.Help
            Me.Appearance.ImageHAlign = Infragistics.Win.HAlign.Right

        ElseIf meTextBoxImageType = ENUM_IMAGETYPE.SEARCH Then
            Me.AutoSize = False
            Me.Appearance.Image = My.Resources.search_textbox
            Me.Appearance.ImageHAlign = Infragistics.Win.HAlign.Right

        End If

    End Sub

    ''' <summary>
    ''' TextBox에Foocus가 나왔을 때 Image 설정 해제
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2015-07-09 민유진 Created
    ''' </remarks>
    Private Sub NABiTextBoxFocusOut(sender As Object, e As EventArgs)

        If meTextBoxImageType = ENUM_IMAGETYPE.HELP OrElse ENUM_IMAGETYPE.SEARCH Then
            Me.AutoSize = False
            Me.Appearance.Image = Nothing
        End If

    End Sub


    ' ''' <summary>
    ' ''' Font style 설정
    ' ''' </summary>
    ' ''' <remarks>
    ' ''' 2015-06-23 민유진 Created
    ' ''' </remarks>
    'Private Sub NABiSetTextBoxFontStyle(meUseTextFontStyle As ENUM_TRUEFALSE)
    '    If meUseTextFontStyle = ENUM_TRUEFALSE.TRUE Then
    '        Me.Appearance.FontData.Name = NABI_FONTNAME
    '        Me.Appearance.FontData.SizeInPoints = NABI_FONTSIZE
    '    Else
    '        Me.Appearance.FontData.Name = Nothing
    '        Me.Appearance.FontData.SizeInPoints = Nothing
    '    End If
    'End Sub

    ''' <summary>
    ''' Font style 설정
    ''' </summary>
    ''' <param name="peFontStyle"></param>
    ''' <remarks></remarks>
    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle
        If peFontStyle = ENUM_TRUEFALSE.TRUE Then
            Me.Appearance.FontData.Name = NABI_FONTNAME
            Me.Appearance.FontData.SizeInPoints = NABI_FONTSIZE
        ElseIf peFontStyle = ENUM_TRUEFALSE.FALSE Then
            Me.Appearance.FontData.Name = Nothing
            Me.Appearance.FontData.SizeInPoints = Nothing
        End If

    End Sub

    ''' <summary>
    ''' nabistyle 사용 설정
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub NABiSetNABiStyle()

        If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then
            Me.BorderStyle = Infragistics.Win.UIElementBorderStyle.Rounded1
            Me.DisplayStyle = Infragistics.Win.EmbeddableElementDisplayStyle.Default
            Me.UseOsThemes = Infragistics.Win.DefaultableBoolean.False

        End If

    End Sub

#End Region

#Region " Events "

    ''' <summary>
    ''' MouseOver 됐을 때 Event
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub NABiTextBox_MouseHover(sender As Object, e As EventArgs) Handles Me.MouseHover

        NABiTextBoxFocusIn(sender, e)

    End Sub

    ''' <summary>
    ''' MouseLeave 됐을 때 Event
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub NABiTextBox_MouseLeave(sender As Object, e As EventArgs) Handles Me.MouseLeave

        If Not Me.Focused Then
            NABiTextBoxFocusOut(sender, e)
        End If

    End Sub

#End Region

End Class
