﻿Imports System.ComponentModel

Public Class NABiToolTipManager
    Inherits Infragistics.Win.UltraWinToolTip.UltraToolTipManager
    Implements iNABiControlProperty

#Region " Private Fields "

    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE
    Private meUseFontStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.NONE

#End Region

#Region " Properties "

    <CategoryAttribute("NABi Design"), Browsable(True), Description("font style 설정 (맑은고딕/9pt)")>
    Public Property NABiUseFontStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseFontStyle
        Get
            Return meUseFontStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseFontStyle = Value
            NABiSetFontStyle(meUseFontStyle)
        End Set
    End Property


    <CategoryAttribute("NABi Design"), Browsable(True), Description("NABi 툴팁 스타일 설정")>
    Public Property NABiUseNABiStyle As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiUseNABiStyle
        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value
            NABiSetToolTipStyle()
        End Set
    End Property

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataProtect As ENUM_TRUEFALSE Implements iNABiControlProperty.NABiDataProtect

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiDataType As ENUM_PROTECTDATA Implements iNABiControlProperty.NABiDataType

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindDTL As ENUM_BINDDETAIL Implements iNABiControlProperty.NABiBindDTL

    <CategoryAttribute("NABi Design"), Browsable(False), Description("숨김 속성")>
    Public Property NABiBindMaster As ENUM_BINDMASTER Implements iNABiControlProperty.NABiBindMaster

#End Region

#Region " Public Methods "

    Public Sub NABiSetFontStyle(peFontStyle As ENUM_TRUEFALSE) Implements iNABiControlProperty.NABiSetFontStyle
        If peFontStyle = ENUM_TRUEFALSE.TRUE Then
            Me.Appearance.FontData.Name = NABI_FONTNAME
            Me.Appearance.FontData.SizeInPoints = NABI_FONTSIZE
        End If
    End Sub

#End Region

#Region " Private Methods "

    ''' <summary>
    ''' TooltipStyle
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub NABiSetToolTipStyle()

        If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then
            Me.Appearance.BackColor = Color.FromArgb(189, 226, 244)
            Me.Appearance.BackColor2 = Color.FromArgb(179, 216, 234)
            Me.Appearance.BackGradientStyle = Infragistics.Win.GradientStyle.Vertical
            Me.Appearance.BorderColor = Color.FromArgb(179, 216, 234)
            Me.DisplayStyle = Infragistics.Win.ToolTipDisplayStyle.BalloonTip

        End If
    End Sub

#End Region

End Class
